<?php
/**
* HELIUM V Synchronisation Modul for Magento 1.7.x
*
* Copyright (C) 2013 HELIUM V IT-Solutions GmbH
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* According to sec. 7 of the GNU Affero General Public License, version 3,
* the terms of the AGPL are supplemented with the following terms:
*
* "Helium V" and "Helium 5" are registered trademarks of HELIUM V IT-Solutions GmbH.
* The licensing of the Program under the AGPL does not imply a trademark license.
* Therefore any rights, title and interest in our trademarks remain entirely with us.
* If you want to propagate modified versions of the Program under the
* name "Helium V" or "Helium 5", you may only do so if you have a written permission
* by Helium V IT-Solutions GmbH (to acquire a permission please contact
* Helium V IT-Solutions at trademark@heliumv.com).
*      
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
* 
* @category Heliumv
* @package  Heliumv_Synchronization
* @author   Maximilian Hehenwarter <developers@heliumv.com>
* @license  http://www.gnu.org/licenses/  Affero General Public License (AGPL 3.0) 
*/

/**
* Hier werden alle Datenverarbeitungen und Helper für Artikelsync und Artikelimport abgelegt
*/
class Heliumv_Synchronization_Model_Article extends Mage_Core_Model_Abstract
{
    /** Logfile deklaration für artikel, zugriff mit self::$logfile_name */
    private static $logfile_name="hv_articlesync.log"; 
    /** Logfile deklaration für category, zugriff mit self::$category_logfile_name */
    private static $category_logfile_name="hv_categorysync.log";
    
    /**
    * Test aufruf artikelclasse
    * @param mixed $input - random input -> output
    */
    public function test($input="")
    {
        return "ja ich kann das article modell jetzt aufrufen, input war: >>".print_r($input,true)."<<";
    }
    
    /**
    * Test fast cat save
    */
    public function test_fast_categorysave()
    {
            
        $category_sample=mage::getModel("catalog/category")->load(232);
        
            $data[] = array(
            '_root' => 'Default Category',
            '_category' => 'Test3',
            'name' => 'TestTest',
            'description' => 'Test3',
            'is_active' => 'yes',
            'include_in_menu' => 'yes',
            'meta_description' => '',
            'available_sort_by' => 'position',
            'default_sort_by' => 'position',
        );
        
        
        
        /** @var $import AvS_FastSimpleImport_Model_Import */
            $import = Mage::getModel('fastsimpleimport/import');
            $import
                ->setPartialIndexing(true)
                ->setBehavior(Mage_ImportExport_Model_Import::BEHAVIOR_APPEND)
                ->processCategoryImport($data);
    
    }
    
    
    
    
    /**
    * Test function artikel import
    * 
    */
    /*public function test_fast_articlesave()
    {

        

        // Create/Update products
        $data = array();
        


            $randomString = "nr".rand(1,7634764)."-".$i."rand";
            $data[] = array(
                'sku' => $randomString,
                '_type' => 'simple',
                '_attribute_set' => 'Default',
                '_product_websites' => 'base',
                '_category' => 'Drahtringe',
                'name' => $randomString,
                'price' => 0.99,
                'special_price' => 0.90,
                'cost' => 0.50,
                'description' => 'Default',
                'short_description' => 'Default',
                'meta_title' => 'Default',
                'meta_description' => 'Default',
                'meta_keywords' => 'Default',
                'weight' => 11,
                'status' => 1,
                'visibility' => 4,
                'tax_class_id' => 2,
                'qty' => 0,
                'is_in_stock' => 0,
                'enable_googlecheckout' => '1',
                'gift_message_available' => '0',
                'url_key' => strtolower($randomString),
            );

        
        //TODO 1: standardfall: ermittle sku<->externalID und ob sich die sku geändert hat, wenn nicht alles OK 
        //TODO 1: wenn doch -> sonderfall durch wechsel von sku abfangen durch zuerst manuell ändern der sku
        //Eventuell auch bei category zu berücksichtigen
        //Es gibt eine methode zum setzen einzelner attribute, diese hier verwenden !!!
        
        //vollständiger beispieldatensatz aus export mit allen pflichtfeldern befüllt mit defaultwerten
        $sku="1234-".rand(1111,9999);
        $xxdata[] = array(
            "sku" => $sku ,    //mandatory und identifier
            "_store" => "0" ,  //mandatory
            "_attribute_set" => "Default" ,  //mandatory
            "_type" => "simple" ,      //mandatory
            "_category" => "test2_cat/test_unter2_cat" ,  //pfad aus cat_entity mit namen -> eventuell besser separat über set attribut setzen
            "_root_category" => "" ,   //root_cat aus cat_entity mit namen -> eventuell besser separat über set attribut setzen
            "_product_websites" => "" , 
            "color" => "" , "cost" => "" , 
            "country_of_manufacture" => "" , 
            "created_at" => "" , 
            "custom_design" => "" , 
            "custom_design_from" => "" , 
            "custom_design_to" => "" , 
            "custom_layout_update" => "" , 
            "description" => "beschreibung" , //mandatory 
            "enable_googlecheckout" => "" , 
            "external_pid" => "" , 
            //"gallery" => "" ,    //leeres object verursacht möglicherweise probleme beim speichern der bilder
            "gift_message_available" => "" , 
            "has_options" => "" , 
            "image" => "test.jpg" , //großes bild, muss unter /media/import/test.jpg vorhanden sein, wird nach /media/catalog/product/t/e/test.jpg kopiert 
            "image_label" => "" , 
            "manufacturer" => "" , 
            "media_gallery" => "" , 
            "meta_description" => "" , 
            "meta_keyword" => "" , 
            "meta_title" => "" , 
            "minimal_price" => "" , 
            "msrp" => "" , 
            "msrp_display_actual_price_type" => "" , 
            "msrp_enabled" => "" , 
            "name" => "product_name" ,  //mandatory
            "news_from_date" => "" , 
            "news_to_date" => "" , 
            "options_container" => "" , 
            "page_layout" => "" , 
            "price" => "20" ,     //mandatory
            "required_options" => "" , 
            "short_description" => "short_description" ,  //mandatory
            "small_image" => "test2.jpg" , //kleinens bild - benötigt bild2 als zusätzliches mediaattribut in 2. zeile
            "small_image_label" => "" , 
            "special_from_date" => "" , 
            "special_price" => "" , 
            "special_to_date" => "" , 
            "status" => "1" , //mandatory 
            "sync_ts" => "" , 
            "tax_class_id" => "0" , //mandatory
            "thumbnail" => "test.jpg" , //thumbnail
            "thumbnail_label" => "" , 
            "updated_at" => "" , 
            "url_key" => "" , 
            "url_path" => "" , 
            "visibility" => "4" , //mandatory
            "weight" => "0" , //mandatory
            "qty" => "9998" ,   //mandatory   - menge gesetzt
            "min_qty" => "0" , //mandatory 
            "use_config_min_qty" => "1" , 
            "is_qty_decimal" => "0" , //mandatory
            "backorders" => "0" , //mandatory
            "use_config_backorders" => "1" , //mandatory
            "min_sale_qty" => "10" , //mandatory  - 10 entspricht 10€ mindestbestellwert ??
            "use_config_min_sale_qty" => "1" , //mandatory 
            "max_sale_qty" => "0" , //mandatory  - 0=unendlich ??
            "use_config_max_sale_qty" => "1" , //mandatory 
            "is_in_stock" => "1" , //mandatory - wenn menge gesetzt dann auch in stock aktiv
            "notify_stock_qty" => "" , 
            "use_config_notify_stock_qty" => "1" , //mandatory
            "manage_stock" => "0" , //mandatory 
            "use_config_manage_stock" => "1" , //mandatory
            "stock_status_changed_auto" => "" , 
            "use_config_qty_increments" => "1" , //mandatory
            "qty_increments" => "0" , //mandatory 
            "use_config_enable_qty_inc" => "" , 
            "enable_qty_increments" => "0" ,  //mandatory
            "is_decimal_divided" => "0" , //mandatory 
            "_links_related_sku" => "" , 
            "_links_related_position" => "" , 
            "_links_crosssell_sku" => "" , 
            "_links_crosssell_position" => "" , 
            "_links_upsell_sku" => "" , 
            "_links_upsell_position" => "" , 
            "_associated_sku" => "" , 
            "_associated_default_qty" => "" , 
            "_associated_position" => "" , 
            "_tier_price_website" => "all" ,    //mengenstaffeln pro kundengruppe
            "_tier_price_customer_group" => "3" , //nummer der kundengruppe, alle = "all"
            "_tier_price_qty" => "10" ,    //menge
            "_tier_price_price" => "17" ,  //sonderpreis für menge
            "_group_price_website" => "all" ,   //sonderpreise für gruppen
            "_group_price_customer_group" => "1" ,  //nummer der kundengruppe
            "_group_price_price" => "17" ,    //preis für diese gruppe
            "_media_attribute_id" => "88" ,   //should be the ID value for the media attribute, in my case 88, siehe auch eav_attribute 
            "_media_image" => "test.jpg" , 
            "_media_lable" => "" , 
            "_media_position" => "1" , //mandatory wenn bild in _media_image übergeben wird, reihenfolge der bilddarstellung
            "_media_is_disabled" => "0" //mandatory wenn bild in _media_image übergeben wird
        );
        
        //setzen von zusätzlichen 2 category
        $xxdata[] = array(
            "_category" => "test2_cat" ,
            "_tier_price_website" => "all" ,    //mengenstaffeln pro kundengruppe
            "_tier_price_customer_group" => "all" , //nummer der kundengruppe, alle = "all"
            "_tier_price_qty" => "100" ,    //menge
            "_tier_price_price" => "17",   //sonderpreis für menge
            "_group_price_website" => "all" ,   //sonderpreise für gruppen
            "_group_price_customer_group" => "3" ,  //nummer der kundengruppe
            "_group_price_price" => "16" ,    //preis für diese gruppe
            //übergabe von weiterem bild, verwendung oben unter small_image zb
            "_media_attribute_id" => "88" ,   //should be the ID value for the media attribute, in my case 88, siehe auch eav_attribute 
            "_media_image" => "test2.jpg" , 
            "_media_lable" => "" , 
            "_media_position" => "2" , //mandatory wenn bild in _media_image übergeben wird, reihenfolge der bilddarstellung
            "_media_is_disabled" => "0" //mandatory wenn bild in _media_image übergeben wird, wird bild angezeigt
        );
        $xxdata[] = array(
            "_category" => "test" ,
            "_tier_price_website" => "all" ,    //mengenstaffeln pro kundengruppe
            "_tier_price_customer_group" => "1" , //nummer der kundengruppe, alle = "all"
            "_tier_price_qty" => "10" ,    //menge
            "_tier_price_price" => "17.5"   //sonderpreis für menge
        );
        

        
        mage::log("Start Import 1 Artikel",null,"test_import_v2.log");
        try {
            if(!file_exists(mage::getBaseDir("media").DIRECTORY_SEPARATOR."import"))
                mkdir(mage::getBaseDir("media").DIRECTORY_SEPARATOR."import");
            
            
            
            // @var $import AvS_FastSimpleImport_Model_Import /
            //$import = Mage::getModel('fastsimpleimport/import');
            $import = new AvS_FastSimpleImport_Model_Import();
            
            //setze lock bzw warte auf nächsten freien lock
            $lock = new Mage_Index_Model_Process();
            $lock->setId("artikel_test");
            $lock_wait=microtime(1);
            $lock->lockAndBlock();
            mage::log("Dauer getlock artikel_test: ".number_format(microtime(1)-$lock_wait,4),null,"test_import_v2.log"); 
            $time = microtime(true);
            
            $import
                ->setPartialIndexing(true)
                ->setBehavior(Mage_ImportExport_Model_Import::BEHAVIOR_APPEND)
                ->processProductImport($data);
            
            //beende lock
            $lock->unlock(); 
                
            mage::log('Finisched - Dauer Artikelsave: ' . round(microtime(true) - $time, 2) . 's',zend_log::INFO,"test_import_v2.log");
            return "OK";
        } catch (Exception $e) {
            //beende lock
            $lock->unlock();  
            
            mage::log("Exception:".print_r($import->getErrorMessages(),1)." - ".print_r($e->getMessage(),1)." trace:\n".$e->getTraceAsString(),zend_log::ERR,"test_import_v2.log");
            return null;
        }

        
        
    }*/
    
    /**
    * Test function artikel import
    * 
    */
    public function test_articlesave_display_in_shop()
    {

        // Create/Update products
        $data = array();
        
            $randomString = "nr".rand(1,7634764)."-rand";
            $data[] = array(
                'sku' => $randomString,
                '_type' => 'simple',
                '_attribute_set' => 'Default',
                '_product_websites' => 'base',
                '_category' => 'Drahtringe',
                'name' => $randomString,
                'price' => 0.99,
                'special_price' => 0.90,
                'cost' => 0.50,
                'description' => 'Default',
                'short_description' => 'Default',
                'meta_title' => 'Default',
                'meta_description' => 'Default',
                'meta_keywords' => 'Default',
                'weight' => 11,
                'status' => 1,
                'visibility' => 4,
                'tax_class_id' => 2,
                'qty' => 999,
                'is_in_stock' => 1,
                'enable_googlecheckout' => '1',
                'gift_message_available' => '0',
                'url_key' => strtolower($randomString),
            );

        try {

            // @var $import AvS_FastSimpleImport_Model_Import /
            //$import = Mage::getModel('fastsimpleimport/import');
            $import = new AvS_FastSimpleImport_Model_Import();

            /*$import
                ->setPartialIndexing(true)
                ->setBehavior(Mage_ImportExport_Model_Import::BEHAVIOR_APPEND)
                ->processProductImport($data); */
                
            $import->processProductImport($data);
            
            //aktualisiere index
            $indexingProcesses = Mage::getSingleton('index/indexer')->getProcessesCollection();
            foreach ($indexingProcesses as $process)
            {
                $process->reindexEverything();
            }
                
            return "OK";
        } catch (Exception $e) {
            
            mage::log("Exception:".print_r($import->getErrorMessages(),1)." - ".print_r($e->getMessage(),1)." trace:\n".$e->getTraceAsString(),zend_log::ERR,"test_import_v2.log");
            return null;
        }

    }
    
    /**
    * Test artikle save paralell
    * 
    */
    /*public function test_fast_articlesave_paralell()
    {

        $artikle_sku=rand(123,99999999999999999999);
        $artikle_sku="38";
        
        // Create/Update products
        $data = array();

            $randomString = "nr".$artikle_sku."rand";
            $data[] = array(
                'sku' => $artikle_sku,
                '_type' => 'simple',
                '_attribute_set' => 'Default',
                '_product_websites' => 'base',
                //'_root_category' => "Default Category",
                //'_root_category' => "235",
                //'_root_category' => "test1",
                //'_category' => "test1/test2", //working !!!
                //'_category' => "Default Category",  //not woirking
                '_category' => "Default Category/Drahtringe",  //working!!
                //'_category' => "236",
                //'_category' => "test2",
                'name' => $randomString,
                'price' => 0.99,
                'special_price' => 0.90,
                'cost' => 0.50,
                'description' => 'Default',
                'short_description' => 'Default',
                'meta_title' => 'Default',
                'meta_description' => 'Default',
                'meta_keywords' => 'Default',
                'weight' => 11,
                'status' => 1,
                'visibility' => 4,
                'tax_class_id' => 2,
                'qty' => 0,
                'is_in_stock' => 0,
                'enable_googlecheckout' => '1',
                'gift_message_available' => '0',
                'url_key' => strtolower($randomString),
            );
            
            $data[] = array(
                '_category' => "test1/test2", //working
            );
            
            $data[] = array(
                '_category' => "test1/test2/test3", //working
            );


        $time = microtime(true);
        mage::log("Start Import Artikel:".$artikle_sku." ",null,"test_import_v2.log");
        try {
            if(!file_exists(mage::getBaseDir("media").DIRECTORY_SEPARATOR."import"))
                mkdir(mage::getBaseDir("media").DIRECTORY_SEPARATOR."import");
            
            // @var $import AvS_FastSimpleImport_Model_Import 
            $import = Mage::getModel('fastsimpleimport/import');
            $import
                ->setPartialIndexing(true)
                ->setBehavior(Mage_ImportExport_Model_Import::BEHAVIOR_APPEND)
                ->processProductImport($data);
            mage::log('Dauer: ' . round(microtime(true) - $time, 2) . 's',null,"test_import_v2.log");
            return "OK";
        } catch (Exception $e) {
            mage::log("Exception:".print_r($import->getErrorMessages(),1)." - ".$e->getMessage()." trace:\n".$e->getTraceAsString(),zend_log::ERR,"test_import_v2.log");
            return null;
        }

    } */
    
    
    /**
    * Hauptfunktion um Artikelsyncronisation anzustoßen
    * 
    * @param string $type "update" = Nur neue Daten werden aktualisiert, "full" = alle Daten werden syncronisiert
    * @param bool $do_category_sync = wenn 0 dann wird der CategorySync vor dem Artikelsync nicht ausgeführt, Risiko dass Artikel ohne Kategorien importiert werden, nur für testzwecke verwenden!!
    */
    public function doArticleSync($type,$do_category_sync=1)
    { 
        //wenn Helium nicht erreichbar abbruch
        $ping=Heliumv_Synchronization_Helper_Master::doPingHV(true);
        if($ping!=1)
            return null;
        
        //speichere sync-start UTC Zeitstempel um ihn nachher bei erfolg zu setzen
        $ts_sync_start=gmdate("Y-m-d H:i:s");
        $abbruch_counter_max=Mage::getStoreConfig('synchronization/debug/max_sync_article'); //debugoption, bricht verarbeitung nach x artikeln ab
        $abbruch_counter=0;
        
        //prüfe auf gültigen typ
        if($type!="update" && $type!="full")
        {
            mage::log("ArticleSync Typ ".$type." wird nicht unterstützt, Abbruch.",zend_log::ERR,self::$logfile_name);
            return null;
        }
        
        //aktualisiere alle kategorien, full oder update je nach setting
        //im Fehlerfall wird kategorie nicht erstellt, logeintrag erstellt und artikel wird unter error_kategorie gehängt
        if($do_category_sync==1)
        {
            $this->doCategorySync($type);   
        }
        
        //lade artikelliste aus HV
        $article_list=$this->getArticleList($type);
        
        //bei vollsync deaktiviere alle aus HV kommenden artikel welche nicht in aktuellem sync vorhanden sind 
        if($type=="full")
            $this->disableOldArticles($article_list);
        
        //erzwinge selbe datenstruktur egal ob ein element oder mehrere zurückkommen
        if(isset($article_list->return->items->item)) //zugriff bei mehreren elementen
            $loop_data=$article_list->return->items->item;
        elseif(isset($article_list->return->items))  //zugriff wenn es nur ein element gibt
            $loop_data=$article_list->return->items;
        
        //gehe durch alle artikel
        foreach ($loop_data as $item)
        {

            $hv_pid=$item->id;   
             
            //starte soapcall für details und speichern des artikels in magento syncron oder asyncron
            if(Heliumv_Synchronization_Helper_Master::getAsyncFlag())
            {
                //erstelle scheduler element für async verarbeitung
                $scheduler_obj=new Heliumv_Synchronization_Model_Scheduler();
                //$scheduler_obj->createSchedulerElement(get_class($this),"processArticleDetails",$hv_pid);
                $scheduler_obj->createSchedulerElement(get_class($this),"processArticleDetails",array($hv_pid));
                //$this->processArticleDetails($hv_pid);   
            }
            else
            {
                //verarbeite prozess syncron
                $this->processArticleDetails($hv_pid);    
            }

            
            //breche verarbeitung ab wenn debug option maximale artikel/kategorien eingestellt ist
            if($abbruch_counter_max!="" && $abbruch_counter_max!=0 && $abbruch_counter>=$abbruch_counter_max)
            {
                mage::log("doCategorySync abgebrochen weil Maximale Debug Categorien auf ".$abbruch_counter_max." gestellt waren.",zend_log::ERR,self::$logfile_name); 
                return null;
            }
            else
            {
                $abbruch_counter++;    
            }
        }
        
        
        //nach artikelsync aktualisiere alle indexe, unklar ob das benötigt wird bzw wie bei asyncroner Verarbeitung umsetzbar
        if(Heliumv_Synchronization_Helper_Master::getAsyncFlag())
        {
            //erstelle scheduler element für async verarbeitung, prio 4, also nach artikel aufrufen
            $scheduler_obj=new Heliumv_Synchronization_Model_Scheduler();
            $scheduler_obj->createSchedulerElement(get_class($this),"refreshIndex",array("catalog_product_price"),4);
        }
        else
        {
            //verarbeite prozess syncron
            $this->refreshIndex("catalog_product_price");  
        }
        
        
        //wenn alles ok setze sync ts (bewusst bei beiden typen full und update gesetzt, gilt für artikel und categorien)
        Mage::getConfig()->saveConfig('synchronization/synctools/last_sync_ts', $ts_sync_start );
        Mage::getConfig()->reinit();
        Mage::app()->reinitStores();
        Mage::log("Setze Zeitstempel letzter Artikelsync auf ".$ts_sync_start,null,self::$logfile_name);    
    }
    
    /**
    * Verarbeitet Artikeldetails (Soapcall + Speicherung Artikel), wird syncron und asyncron verwendet
    * @param mixed $hv_pid - Übergabe von helium Artikel ID
    */
    public function processArticleDetails($hv_pid)
    {
        //artikeldetails von HV laden
        $articel_detail=$this->getArticleDetails($hv_pid);
            
        //artikel in product, categorie(n) und stock objecten speichern/aktualisieren
        if($articel_detail!=NULL)
        {
            $magento_pid=$this->saveArticelAttributes($hv_pid,$articel_detail);
        }
        
        //return nur wenn variable gesetzt und nicht null
        if($magento_pid!=null)
        {
            //mage::log("Verarbeitung von ArtikelID (HV/Magento):".$hv_pid."/".$magento_pid." erfolgreich",zend_log::INFO,self::$logfile_name);
            return $magento_pid;
        }
        else
        {
            return null;
        }       
    }
    
    /**
    * Verarbeitet Categoriedetails (Soapcall + Speicherung Category), wird syncron und asyncron verwendet
    * 
    * @param mixed $external_gid - externe ShopgruppenID aus HV
    * @param mixed $magento_parent_id - Magento Category ID des übergeordneten Objects
    * @return liefert magento category ID zurück, oder null im fehlerfall
    */
    public function processCategoryDetails($external_gid,$magento_parent_id)
    {
        //category details von HV laden
        $category_detail=$this->getCategoryDetails($external_gid);
        
        //variablen für erstellung cat zusammentragen
        $category_name=$category_detail->return->webshopGroup->name;
        if(isset($category_detail->return->webshopGroup->referenceItem->id) && (int)$category_detail->return->webshopGroup->referenceItem->id!=0)
            $external_reference_pid=$category_detail->return->webshopGroup->referenceItem->id;
        else
            $external_reference_pid=null;
        $enable_cat=true;
            
        //category speichern/aktualisieren und mögliche bilder speichern / aktualisieren
        if($category_detail!=NULL)
            $magento_gid=$this->saveCategory($magento_parent_id,$category_name,$external_gid,$external_reference_pid,$enable_cat);
        
        //return nur wenn variable gesetzt und nicht null
        if($magento_gid!=null)
            return $magento_gid;
        else
            return null;                
    }
    
    /**
    * Funktion aktualisiert denb Preisindex, nach Artikelsync benötigt
    */
    
    /**
    * Funktion aktualisiert Indexe, entweder alle oder bestimmte, nach Artikelsync zb mit Aufruf catalog_product_price benötigt
    * @param mixed $name - name des indexes, optional, detail=all
    */
    public function refreshIndex($name="all")
    {
        $return=null;
        $found=0;
        try
        {
            $indexingProcesses = Mage::getSingleton('index/indexer')->getProcessesCollection();
            foreach ($indexingProcesses as $process)
            {
                if($name!="all")
                {
                    if($process->getIndexerCode()==$name)
                    {
                        $process->reindexEverything();
                        $found=1;
                    }
                }
                else
                {
                    $process->reindexEverything();
                }
            }
            if($name=="all")
            {
                mage::log("refreshIndex - All Index rebuild OK",zend_log::INFO,self::$logfile_name);
                $return=true;
            }
            elseif($found==1)
            {
                mage::log("refreshIndex - Index ".$name." rebuild OK",zend_log::INFO,self::$logfile_name);
                $return=true;
            }
            else
            {
                mage::log("refreshIndex - Index ".$name." not found, no rebuild",zend_log::WARN,self::$logfile_name);
                $return=null;
            }    
        }
        catch(Exception $e)
        {
            mage::log("refreshIndex - Exception bei Index catalog_product_price, Message:".$e->getMessage(),zend_log::ERR,self::$logfile_name);
            $return = null;    
        }
        
        return $return;
        
    }
    
    
    /**
    * Gibt Liste von zu importierenden Artikeln zurück
    * @param string $type "update" = Nur neue Daten werden aktualisiert, "full" = alle Daten werden syncronisiert
    * @return liefert soap-result oder im fehlerfall null zurück
    */
    private function getArticleList($type)
    {
        
        $options = array('trace' => 1);
        $login = Heliumv_Synchronization_Helper_Master::getWebserviceHeaderData();
        $server_url=Heliumv_Synchronization_Helper_Master::getWebserviceUrlArticle();
        $return=null;
        
        //ermittle letztgültigen sync zeitstempel
        if($type=="update")
        {
            $ts_sync=gmdate("Y-m-d H:i:s"); //initialwert utc ts setzen
            $ts_last_sync=Mage::getStoreConfig('synchronization/synctools/last_sync_ts');
            if(isset($ts_last_sync) and $ts_last_sync!="" and strtotime($ts_last_sync)>0)
            {
                $ts_sync=$ts_last_sync;  
            }
            mage::log("Verwende Zeitstempel letzter Artikelsync ".$ts_sync,null,self::$logfile_name);
        }
        
        try
        {
            //prevent running into a timeout
            set_time_limit(Mage::getStoreConfig('synchronization/heliumvconnect/soap_timeout'));
            
            //neuen soapclient aufmachen
            $client = new SoapClient($server_url,$options);
            
            //get items from the heliumv instance
            if($type=="update")
                $result = $client->getItemsChanged(array('arg0' => $login,'changedDateTime' => $ts_sync)); 
            if($type=="full")
                $result = $client->getItems(array('arg0' => $login));     
            
            //bei positiver rückmeldung
            if ($result->return->rc == 0 && isset($result->return->items))
            {                
                $return= $result;
            }
            else
            {
                mage::log("getArticleList - Keine Artikel gefunden oder RC<>0 bei Rückgabe. (RC=".$result->return->rc.", ItemAnzahl=".count($result->return->items).", Typ=".$type.")",zend_log::ERR,self::$logfile_name);
                $return=null;
            }
        }
        catch(SoapFault $exc)
        {
            mage::log("getArticleList - Exeption:".$exc,zend_log::ERR,self::$logfile_name);       
            $return=null; 
        }    
        
        //wenn debug aktiv schreibe request und response in debug
        if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
        {
            Heliumv_Synchronization_Helper_Master::debugLog("getArticleList_request.xml",$client->__getLastRequest() ,"no",gmdate("Ymd"));
            Heliumv_Synchronization_Helper_Master::debugLog("getArticleList_response.xml",$client->__getLastResponse() ,"no",gmdate("Ymd"));
        }
        
        $client=null; //soap client object deaktivieren
        return $return ;
    }
    
    /**
    * Liest Details zu Artikel aus
    * @param mixed $pid HV Artikel Id
    * @return liefert soap-result oder im fehlerfall null zurück
    */
    private function getArticleDetails($pid)
    {
        
        //initialisierung
        $logfile_name="articlesync.log";
        
        $options = array('trace' => 1);
        $login = Heliumv_Synchronization_Helper_Master::getWebserviceHeaderData();
        $server_url=Heliumv_Synchronization_Helper_Master::getWebserviceUrlArticle();
        $return=null;
        
        try
        {
            //prevent running into a timeout
            set_time_limit(Mage::getStoreConfig('synchronization/heliumvconnect/soap_timeout'));
            //neuen soapclient aufmachen
            $client = new SoapClient($server_url,$options);
            //get item from the heliumv instance
            $result = $client->getItemFindById(array('arg0' => $login,'id' => $pid)); 

            //bei positiver rückmeldung
            if ($result->return->rc == 0 && isset($result->return->item->bmeCatInfo))
            {                
                $return=$result;
            }
            else
            {
                mage::log("getArticleDetails - Keine Daten zu Artikel ".$pid." gefunden oder RC<>0 bei Rückgabe. (RC=".$result->return->rc.")",zend_log::ERR,self::$logfile_name);
                $return=null;
            }
        }
        catch(SoapFault $exc)
        {
            mage::log("getArticleDetails Artikel:".$pid." - Exeption:".$exc->getMessage(),zend_log::ERR,self::$logfile_name);       
            $return=null;  
        }      
        
        //wenn debug aktiv schreibe request und response in debug
        if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
        {
            Heliumv_Synchronization_Helper_Master::debugLog("getArticleDetails_".$pid."_request.xml",$client->__getLastRequest() ,"no",gmdate("Ymd"));
            Heliumv_Synchronization_Helper_Master::debugLog("getArticleDetails_".$pid."_response.xml",$client->__getLastResponse() ,"no",gmdate("Ymd"));
        }
        
        $client=null;
        return $return;
    }
    
    /**
    * Erstellt Dummy Artikel Entity um danach mit Daten gefüllt zu werden
    * @return Entity_id wenn OK, im Fehlerfall null
    */
    /*public function createDummyArticle_old()
    {
        $product = new Mage_Catalog_Model_Product();
        $product->setAttributeSetId(Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/product'));
        $product->setTypeId('simple');
        $product->setName('Dummy Product');
        $product->setPrice("1");
        $product->setWeight(0);
        $product->setStatus(0);
        $product->setCreatedAt(strtotime('now'));   
        try {
            $product->save();
            $id=$product->getId();
            $product->clearInstance(); //object aus speicher löschen
            mage::log($id." - created",null,"dummytest.log");
            return $id;
        }
        catch (Exception $ex) {
            mage::log("Exeption".$ex->getMessage(),zend_log::ERR,"dummytest.log");
            return null;
        }
    }*/
    
    /**
    * Erstellt Dummy Product Entity via SQL um danach mit Daten gefüllt zu werden
    * @param - optional: kann die sku übergeben werden
    * @return Entity_id wenn OK, im Fehlerfall null
    */
    /*public function createNewDummyProductEntity_disabled($sku=null)
    {
        //TODO 1: problem mit index erstellung !!!!!
        return null;
        
        //initialisierung
        $entityType = Mage::getModel('eav/config')->getEntityType('catalog_product');
        $entityTypeId =  $entityType->getEntityTypeId();
        $attribute_set_id = $entityType->getDefaultAttributeSetId();
        $resource = Mage::getSingleton('core/resource');
        // @var $db_write Mage_Core_Model_Resource_Db_Abstract 
        $db_write = $resource->getConnection('core_write');
        $lock = new Mage_Index_Model_Process();
        $lock->setId("create_new_product_entity");

        try {              

            //lock setzen 
            $save_start=microtime(1);
            $lock->lockAndBlock();

            //insert neue product entity in DB wenn sku ist null
            if($sku==null)
            {
                $sql="insert into ".$resource->getTableName("catalog_product_entity")." (entity_type_id,attribute_set_id) values (".$entityTypeId.",".$attribute_set_id.")";
                $return = $db_write->query($sql);
                $id=$db_write->lastInsertId();
            }
            else
            {
                //sku gesetzt, prüfe zuerst ob schon vorhanden
                $sql="select entity_id from ".$resource->getTableName("catalog_product_entity")." where sku='".$sku."'";
                $return = $db_write->fetchRow($sql);
                if(isset($return[0]["entity_id"]))
                {
                    $id=$return[0]["entity_id"];
                }
                else
                {
                    $sql="insert into ".$resource->getTableName("catalog_product_entity")." (entity_type_id,attribute_set_id,sku) values (".$entityTypeId.",".$attribute_set_id.",'".$sku."')";
                    $return = $db_write->query($sql);
                    $id=$db_write->lastInsertId();    
                }
                
            }
            
            //lock aufheben
            $lock->unlock();
            
            //zeitdauer messen
            mage::log("Neue ProductEntityID:".$id." erstellt, Dauer in sek: ".number_format(microtime(1)-$save_start,4),null,self::$logfile_name);   
            
            return $id;
        }
        catch (Exception $ex) {
            $lock->unlock();
            mage::log("Exeption bei createNewDummyProductEntity:".$ex->getMessage(),zend_log::ERR,self::$logfile_name);
            return null;
        }
    }  */
    
    
    /**
    * Aktualisiert Magento Artikel - alte version über das object, dauert sehr lange
    * @param number $external_pid - entspricht dem Feld external_pid
    * @param mixed $articel_detail - soap response zu diesem artikel mit den details
    * @return number $magento_pid - magento artikel ID
    */
    /*private function saveArticelAttributes_old($external_pid,$articel_detail)
    {
        //initialisierung
        $logfile_name="articlesync.log";
        
        //ermittle magento artikelid zu external_pid
        $magento_pid=$this->convertExternalPidToPid($external_pid);
        
        //lade datenobjekte aus soap response
        $bme_cat_info = simplexml_load_string($articel_detail->return->item->bmeCatInfo);
        $product = $bme_cat_info->T_NEW_CATALOG[0]->PRODUCT[0];
               
        //neues produkt/stock object initialisieren
        $item = Mage::getModel('catalog/product');
        $stock = Mage::getModel('cataloginventory/stock_item');
        $item->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
        $stock->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
        //$item->setAttributeSetId($this->getDefaultAttributeSetId('catalog/product'));  
        $item->setAttributeSetId(Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/product'));
        //$stock->setAttributeSetId($this->getDefaultAttributeSetId('cataloginventory/stock_item'));
        $stock->setAttributeSetId(Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('cataloginventory/stock_item'));  
        
        //TODO 2: eventuell für multishop oder cronjob aufruf ein problem 
        //muss gesetzt sein da es sonnst zu fehlern beim speichern des objects kommt
        //input kam von http://www.magentocommerce.com/boards/26245/viewthread/277380/#t389587
        //Mage::app()->setCurrentStore(Mage_Core_Model_App::ADMIN_STORE_ID);
        Mage::app()->setCurrentStore(Mage::app()->getStore()->getId());
        
        //zusätzliche schritte für neue Artikel
        $dummy_id=null;
        if($magento_pid==null)
        {            
            //externe pid nur dann setzen wenn neuer artikel (kann via update nicht verändert werden)
            $data['external_pid']=$external_pid;    
        }
        else //zusätzliche Schritte für bestehende Artikel
        {
            //bestehende product daten laden
            $item->load($magento_pid);   
            
            //bestehende stock daten zu product laden
            $stock->loadByProduct($magento_pid);
            
            //wenn debug dann alte artikeldaten wegschreiben
            if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
            {
                Heliumv_Synchronization_Helper_Master::debugLog("Product_".$magento_pid."_".$external_pid."_Obj_old.txt",$item,"no",gmdate("Ymd"));
                Heliumv_Synchronization_Helper_Master::debugLog("Product_".$magento_pid."_".$external_pid."_StockObj_old.txt",$stock,"no",gmdate("Ymd"));
            }
             
        }
        
        //weise artikel einer oder mehreren kategorien zu
        $category_ids=array();
        if(isset($articel_detail->return->item->shopgroupids))
        {
            foreach($articel_detail->return->item->shopgroupids as $shopgruppe)
            {
                //prüfung ob shopgruppe in magento vorhanden, sonnst nimm errorgruppe
                $magento_gid=null;
                $magento_gid=$this->convertExternalGidToCategoryId($shopgruppe);
                if($magento_gid==null)
                    $magento_gid=$this->getErrorCategoryId();
                
                array_push($category_ids, $magento_gid);
            }
            $data['category_ids']=$category_ids;
        }
        else
        {
            //setze error category wenn keine category in xml übergeben wird
            $data['category_ids']=array($this->getErrorCategoryId());
            //mage::log("saveArticelAttributes Artikel:".$external_pid." keine Kategorien in XML gefunden, setze Error Category.",zend_log::ERR,self::$logfile_name);    
        }
        
        
        //Todo 1: gruppenpreise und staffelpreise aus SS versorgen, hier nur ein hardcodiertes Beispiel, es gibt noch probleme wenn es mehrfach gesetzt/aktualisiert werden soll, eventuell müssen die daten vorher wieder entfernt werden oder ein eigenes object erstellt und verknüpft werden
        //$data['group_price']=array(array('website_id'=>0, 'cust_group'=>3, 'price'=>(floatval($product->PRODUCT_PRICE_DETAILS->PRODUCT_PRICE->PRICE_AMOUNT)*80/100)));
        //$data['tier_price'] =array(array('website_id'=>0, 'cust_group'=>3, 'price_qty'=> 100,'price' => (floatval($product->PRODUCT_PRICE_DETAILS->PRODUCT_PRICE->PRICE_AMOUNT)*50/100)));    
        
        //einzelne product attribute setzen                     
        $data['sync_ts'] = strtotime('now');
        $data['name'] = $product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT;
        $data['description'] = $product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG ? $product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG : $product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT;
        $data['short_description'] = $product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT;
        $data['price'] = $product->PRODUCT_PRICE_DETAILS->PRODUCT_PRICE->PRICE_AMOUNT;
        $data['sku'] = $articel_detail->return->item->cnr;
        $data['tax_class_id'] = $this->checkTaxClass($product->PRODUCT_PRICE_DETAILS->PRODUCT_PRICE->TAX); //erstellt neue tax class wenn neue MWST vorkommt, muss danach manuell im Shop den tax rules zugewiesen werden
                      
        //diverses einstellungen um product zu aktivieren und anzuzeigen
        $data['attribute_set_id'] = Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/product');
        $data['website_ids'] = Heliumv_Synchronization_Helper_Master::getWebsiteId(); 
        //$data['website_ids'] = array(Mage::app()->getStore(true)->getWebsite()->getId()); 
        $data['type_id'] = Mage_Catalog_Model_Product_Type::TYPE_SIMPLE;
        $data['status'] = Mage_Catalog_Model_Product_Status::STATUS_ENABLED;
        $data['weight'] = 0; //pflichtfeld in gui
        //$data['visibility'] = Mage_Catalog_Model_Product_Visibility::VISIBILITY_BOTH;    
        
        //TODO 1: versuch mediagalery zu initialisieren um sql error zu verhindern
        //$data['media_gallery'] = array("images"=>array(),"values"=>array());
        
        
        //daten in object hinzufügen und speichern             
        try
        {
            $item->addData($data);
            
            //TODO 1: funktioniert manchmal nicht und bleibt mit sql error 1425 hängen
            //bild zu produkt hinzufügen wenn in xml vorhanden
            $picture_path=$this->saveArticlePicture($articel_detail);
            if($picture_path!=null && isset($picture_path["path"]))
            {
                //grundsätzlich geht eines der beiden sqls schief
                //INSERT INTO `catalog_product_entity_media_gallery_value` (`value_id`, `store_id`, `label`, `position`, `disabled`) VALUES ('670', '0', '', '1', '1')
                //insert into catalog_product_entity_media_gallery ( attribute_id, entity_id, value) VALUES ('88', '49', '/2/5/2511-929500w.jpg')
                
                //TODO 1: Problemfall liegt in einer nicht paralellisierbarkeit dieses befehls!!!
                $item->addImageToMediaGallery($picture_path["path"], array("thumbnail", "small_image", "image"),true);    
                

                
                if($magento_pid==null)
                    Mage::log("Bild:".$picture_path["name"]." zu Magento_PID:".$dummy_id." hinzugefuegt.",zend_log::INFO,self::$logfile_name);
                else
                     Mage::log("Bild:".$picture_path["name"]." zu Magento_PID:".$magento_pid." hinzugefuegt.",zend_log::INFO,self::$logfile_name);
                    
            } 
            
            //speichern des products
            $item->save();
            
            if($magento_pid==null)
                mage::log("Artikel mit PID:".$item->getId()." External_PID:".$external_pid." erstellt.",zend_log::INFO,self::$logfile_name);
            else
                mage::log("Artikel mit PID:".$item->getId()." External_PID:".$external_pid." aktualisiert.",zend_log::INFO,self::$logfile_name);
        }
        catch(Exception $ex)
        {
            mage::log("Exeption bei Speichern Artikel External_PID:".$external_pid.", Magento/Dummy_PID:".$magento_pid."/".$dummy_id."  aufgetreten, Exception: ".$ex->getMessage(),zend_log::ERR,self::$logfile_name);
            if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
            {
                Heliumv_Synchronization_Helper_Master::debugLog("ExeptionTrace_ArticleID_".$external_pid.".log",$ex->getTraceAsString(),"no",gmdate("Ymd"));
            }
            return null;
        }
        

        
        
        //stock
        $quantity=9999; //Todo 2: Daten zu Lagerstand sollten in SS übertragen werden, kann ich nicht finden -> wert hardcodiert
        $data_stock['attribute_set_id'] = Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('cataloginventory/stock_item');
        $data_stock['qty'] = $quantity; //lagerbestand greift hier nur bei einem update, wird bestand neu inisiatlisiert muss er erneut aufgemacht und gesetzt werden (magento bug?)
        $data_stock['is_in_stock'] = "1";
        $data_stock['product_id'] = $item->getId(); //hier verknüpfung des stock items mit dem produkt (erst nach speichern des produkts möglich)
        $data_stock['stock_id'] = "1"; //zwingend notwendig für sql insert da foreighn key, wert derzeit hardcodiert, siehe getStockId() in Item.php
        
        //daten in stock object hinzufügen und speichern
        try
        {
            $stock->addData($data_stock); 
            $stock=$stock->save();   
            
            //stock erneut aufmachen und lagerstand erneut setzen, für neue artikel benötigt da sonnst lagerstand 0 (magento bug?)
            $stock2 = Mage::getModel('cataloginventory/stock_item');
            $stock2->load($stock->getId());
            $stock2->addData(array("qty"=>$quantity));
            
            //TODO 2:versuch um inserts im format INSERT INTO `cataloginventory_stock_item` (`qty`) VALUES ('0') im fehlerfall zu verhindern
            $stock2->addData($data_stock); 
            
            $stock2->save();
        }
        catch(Exception $ex)
        {
            mage::log("Fehler beim Speichern von Stock von Artikel PID:".$item->getId().", External_PID:".$magento_pid." aufgetreten, Exception: ".$ex->getMessage(),zend_log::ERR,self::$logfile_name);
            if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
            {
                Heliumv_Synchronization_Helper_Master::debugLog("ExeptionTrace_ArticleStockID_".$external_pid.".log",$ex->getTraceAsString(),"no",gmdate("Ymd"));
            }
            return null;    
        }
    
        //wenn debug dann neue artikeldaten wegschreiben
        if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
        {
            Heliumv_Synchronization_Helper_Master::debugLog("Product_".$item->getId()."_".$external_pid."_Obj_new.txt",$item,"no",gmdate("Ymd"));
            Heliumv_Synchronization_Helper_Master::debugLog("Product_".$item->getId()."_".$external_pid."_StockObj_new.txt",$stock,"no",gmdate("Ymd"));
        }
    
        return $item->getId();
            
    }*/ 
    
    /**
    * Aktualisiert Magento Artikel über AvS Framework
    * @param number $external_pid - entspricht dem Feld external_pid
    * @param mixed $articel_detail - soap response zu diesem artikel mit den details
    * @return number $magento_pid - magento artikel ID
    */
    private function saveArticelAttributes($external_pid,$articel_detail)
    {

        //ermittle magento id / sku zu external_pid
        $magento_pid=$this->convertExternalPidToPid($external_pid);
        $magento_sku=$this->convertExternalPidToSku($external_pid);
        
        //lade datenobjekte aus soap response
        $bme_cat_info = simplexml_load_string($articel_detail->return->item->bmeCatInfo);
        $product = $bme_cat_info->T_NEW_CATALOG[0]->PRODUCT[0];
        
        //prüfe ob artikel schon existiert und sich die sku geändert hat, wenn ja zuerst diese ändern und object speichern, sonnst bfunktioniert AvS Framnework welches die sku als primärkey verwendet nicht
        $hv_sku = $articel_detail->return->item->cnr;
        if($magento_pid!=null && $hv_sku!=null  && $hv_sku!=$magento_sku)
        {
            //object laden und sku ändern
            $change_sku_obj = Mage::getModel('catalog/product');
            $change_sku_obj->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
            $change_sku_obj->setAttributeSetId(Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/product'));
            $change_sku_obj->load($magento_pid);
            $alte_sku=$change_sku_obj->getSku();
            $change_sku_obj->setSku($hv_sku);
            
            //speichern der neuen sku          
            try
            {
                $change_sku_obj->save();
                mage::log("Sku Änderung von MagentoArtikel:".$magento_pid." benoetigt, Aenderung der SKU von ".$alte_sku." auf ".$hv_sku." durchgefuehrt.",zend_log::INFO,self::$logfile_name);
            }
            catch(Exception $ex)
            {
                mage::log("Exception bei Sku Änderung von MagentoArtikel:".$magento_pid." benoetigt, Aenderung der SKU von ".$alte_sku." auf ".$hv_sku." durchgefuehrt, Exception: ".$ex->getMessage(),zend_log::ERR,self::$logfile_name);
            }
        }
        elseif($magento_pid==null && $hv_sku!=null)
        {
            //nehme hv sku als neue sku in magento wenn noch kein artikel in magento gesetzt
            $magento_sku=$hv_sku;
        }
        
        //importiere bild wenn in daten vorhanden
        $picture_big="";
        $picture_path=$this->saveArticlePicture($articel_detail,1);
        if($picture_path!=null && isset($picture_path["name"]))
        {
            $picture_big=$picture_path["name"];    
        } 
        
        //ermittle ein oderer mehrere categorien für artikel
        $category_ids=array();
        if(isset($articel_detail->return->item->shopgroupids->shopgroupid))
        {
            //unterschiedliche zugriffe bei einer oder mehreren elementen
            if(count($articel_detail->return->item->shopgroupids->shopgroupid)==1)
            {
                $shopgruppe=$articel_detail->return->item->shopgroupids->shopgroupid;
                //prüfung ob shopgruppe in magento vorhanden, sonnst nimm errorgruppe
                $magento_gid=null;
                $magento_gid=$this->convertExternalGidToCategoryId($shopgruppe);
                if($magento_gid==null)
                    $magento_gid=$this->getErrorCategoryId();
                array_push($category_ids, $magento_gid);        
            }
            else
            {
                foreach($articel_detail->return->item->shopgroupids->shopgroupid as $shopgruppe)
                {
                    //prüfung ob shopgruppe in magento vorhanden, sonnst nimm errorgruppe
                    $magento_gid=null;
                    $magento_gid=$this->convertExternalGidToCategoryId($shopgruppe);
                    if($magento_gid==null)
                        $magento_gid=$this->getErrorCategoryId();
                    array_push($category_ids, $magento_gid);
                }
            }
        }
        else
        {
            //setze error category wenn keine category in xml übergeben wird
            $category_ids=array($this->getErrorCategoryId());
            if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
                mage::log("saveArticelAttributes Artikel:".$external_pid." hat keine Kategorien in XML gefunden, setze Error Category.",zend_log::WARN,self::$logfile_name);    
        }
        
        //entferne mögliche duplikateinträge aus $category_ids
        $category_ids=array_unique($category_ids);
        
        //konvertiere gesamtes array in namen
        $category_names=array();
        foreach($category_ids as $category_id)
        {
            $name_cat=$this->convertCategoryIDtoCategoryPath($category_id);
            array_push($category_names, array("id" => $category_id, "cat" => $name_cat));
        }
        
        
        //bereite alle preise in defaulktpreis, mengenstaffel und preislisten auf
        $default_preis=array();
        $mengenstaffel=array();
        $preislisten=array();
        if(isset($product->PRODUCT_PRICE_DETAILS->PRODUCT_PRICE))
        {
            foreach($product->PRODUCT_PRICE_DETAILS as $preis_detail)
            {
                $arrributes=$preis_detail->PRODUCT_PRICE->attributes();
                $type=(string)$arrributes["price_type"];
                $preis=(string)$preis_detail->PRODUCT_PRICE->PRICE_AMOUNT;
                $tax_class=$this->checkTaxClass($preis_detail->PRODUCT_PRICE->TAX);
                $staffel_menge=(string)$preis_detail->PRODUCT_PRICE->LOWER_BOUND;
                
                $customergroup="";
                if($type!="net_customer")
                {
                    $temp_gr_nr=null;
                    $temp_gr_nr_array=explode("_",$type);
                    $temp_gr_nr=(int)$temp_gr_nr_array[2];
                    
                    if($temp_gr_nr!=null && $temp_gr_nr>0)
                    {
                        $customer_obj=new Heliumv_Synchronization_Model_Customer();
                        $customergroup=$customer_obj->checkCustomerGroup($temp_gr_nr);
                    }
                }
                
                //keine Mengenstaffel
                if((int)$staffel_menge==1)
                {
                    if($type=="net_customer")
                    {
                        //setze defaultpreis
                        $default_preis=array("type"=>$type, "group_id"=>$customergroup, "preis"=>$preis, "tax_class"=>$tax_class, "menge"=>$staffel_menge);    
                    }
                    else
                    {
                        //setze preislisten
                        array_push($preislisten, array("type"=>$type, "group_id"=>$customergroup, "preis"=>$preis, "tax_class"=>$tax_class, "menge"=>$staffel_menge));        
                    }
                }
                elseif((int)$staffel_menge>=1)
                {
                    //setze mengenstaffel für preislisten
                    array_push($mengenstaffel, array("type"=>$type, "group_id"=>$customergroup, "preis"=>$preis, "tax_class"=>$tax_class, "menge"=>$staffel_menge));          
                }
                else
                {
                    //ungültger wert bei mengenstaffel - error
                    mage::log("error bei preisfindung ArtikelId:".$external_pid.", ungültiger wert (".$staffel_menge.") bei mengenstaffel".zend_log::ERR,self::$logfile_name);
                    return null;
                }
                
            }
        }
        if($default_preis==null)
        {
            //kein standardpreis -> error
            mage::log("error bei preisfindung ArtikelId:".$external_pid.", kein Standardpreis (net_customer mit lower_bound=1) hinterlegt".zend_log::ERR,self::$logfile_name);
            return null;
        }
        
        
        //prüfe ob die wichtigsten pflichtfelder vorhanden sind -> sonnst alles andere beim speichern geprüft
        $errortext="";
        $abbruch=0;
        if((string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT==null || (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT=="")
        {
            $errortext.=" Product ".$external_pid." hat keinen gültigen Namen (".(string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT."), ";
            $abbruch=1;    
        }
        if($default_preis["preis"]=="" || (float)$default_preis["preis"]<=0)
        {
            $errortext.=" Product ".$external_pid." hat keinen gültigen Preis (".$default_preis["preis"]."), ";
            $abbruch=1;    
        }
        if($abbruch==1)
        {
            //melde Fehler auch nach Helium
            Heliumv_Synchronization_Helper_Master::sendErrorToHV(101,"Verarbeitung von ArtikelID:".$external_pid." wegen Stammdatenproblemen abgebrochen",zend_log::ERR,"article",$external_pid,$errortext);
            
            mage::log("Verarbeitung von Product ".$external_pid." abgebrochen, Stammdatenprobleme waren (".$errortext.")",zend_log::ERR,self::$logfile_name);
            return null;
        }
        elseif($errortext!="")
        {
            mage::log("Probleme mit Stammdaten von Product ".$external_pid." aufgetreten (".$errortext.")",zend_log::WARN,self::$logfile_name);
        }
        
        //verhindert fehler bei import
        if(!file_exists(mage::getBaseDir("media").DIRECTORY_SEPARATOR."import"))
            mkdir(mage::getBaseDir("media").DIRECTORY_SEPARATOR."import");
        
        //testdaten working
        $randomString="123".rand(1,222);
        $testdata[]=array(
        'sku' => $randomString,      //ok
        '_type' => 'simple',         //ok
        '_attribute_set' => 'Default',   //ok
        '_product_websites' => 'base',   //test v1
        '_category' => 'Drahtringe',
        'name' => $randomString,
        'price' => 0.99,
        'special_price' => 0.90,
        'cost' => 0.50,
        'description' => 'Default',
        'short_description' => 'Default',
        'meta_title' => 'Default',
        'meta_description' => 'Default',
        'meta_keywords' => 'Default',
        'weight' => 11,
        'status' => 1,        //ok
        'visibility' => 4,
        'tax_class_id' => 2,
        'qty' => 999,
        'is_in_stock' => 1,
        'enable_googlecheckout' => '1',
        'gift_message_available' => '0',
        'url_key' => strtolower($randomString),
        );

        
 
         //vollständiger beispieldatensatz aus export mit allen pflichtfeldern befüllt mit defaultwerten
        $data[] = array(
            "sku" => $magento_sku ,    //mandatory und identifier
            "_store" => Heliumv_Synchronization_Helper_Master::getStoreId() ,  //mandatory
            "_attribute_set" => "Default" ,  //mandatory  - ev vergleichbar mit  Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/product');  ???
            "_type" => Mage_Catalog_Model_Product_Type::TYPE_SIMPLE ,      //mandatory
            "_category" => $category_names[0]["cat"] , //zB "test2_cat/test_unter2_cat" pfad aus cat_entity mit namen -> eventuell besser separat über set attribut setzen
            //"_root_category" => $category_names[0]["root"] ,   // setzen der root category funktioniert hier nicht !!!
            "_product_websites" => Heliumv_Synchronization_Helper_Master::getWebsiteCode() ,  //zwingend erforderlich damit auf homepage angezeigt, defaultwert ist base
            "color" => "" , 
            "cost" => "" , 
            "country_of_manufacture" => "" , 
            "created_at" => "" , 
            "custom_design" => "" , 
            "custom_design_from" => "" , 
            "custom_design_to" => "" , 
            "custom_layout_update" => "" , 
            "description" => (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG ? (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG : (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT , //mandatory 
            "enable_googlecheckout" => "" , 
            "external_pid" => $external_pid ,
            "order_unit" => (string)$product->PRODUCT_ORDER_DETAILS->ORDER_UNIT ? (string)$product->PRODUCT_ORDER_DETAILS->ORDER_UNIT : "Stk" , //setze order unit wie Stk, kg, mm, Liter, etc
            //"gallery" => "" ,    //leeres object verursacht möglicherweise probleme beim speichern der bilder
            "gift_message_available" => "" , 
            "has_options" => "" , 
            "image" => $picture_big , //großes bild, muss unter /media/import/test.jpg vorhanden sein, wird nach /media/catalog/product/t/e/test.jpg kopiert 
            "image_label" => "" , 
            "manufacturer" => "" , 
            "media_gallery" => "" , 
            "meta_description" => "" , 
            "meta_keyword" => "" , 
            "meta_title" => "" , 
            "minimal_price" => "" , 
            "msrp" => "" , 
            "msrp_display_actual_price_type" => "" , 
            "msrp_enabled" => "" , 
            "name" => (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT ,  //mandatory
            "news_from_date" => "" , 
            "news_to_date" => "" , 
            "options_container" => "" , 
            "page_layout" => "" , 
            "price" => $default_preis["preis"] ,     //mandatory
            "required_options" => "" , 
            "short_description" => (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT ,  //mandatory
            "small_image" => $picture_big , //kleinens bild - benötigt bild2 als zusätzliches mediaattribut in 2. zeile
            "small_image_label" => "" , 
            "special_from_date" => "" , 
            "special_price" => "" , 
            "special_to_date" => "" , 
            "status" => Mage_Catalog_Model_Product_Status::STATUS_ENABLED , //mandatory 
            "sync_ts" => "" , 
            "tax_class_id" => $default_preis["tax_class"] , //mandatory, erstellt neue tax class wenn neue MWST vorkommt, muss danach manuell im Shop den tax rules zugewiesen werden
            "thumbnail" => $picture_big , //thumbnail
            "thumbnail_label" => "" , 
            "updated_at" => "" , 
            "url_key" => "" , 
            "url_path" => "" , 
            "visibility" => "4" , //mandatory
            "weight" => "0" , //mandatory
            "qty" => $articel_detail->return->item->quantityAvailable ,   //mandatory   - menge wird auf in helium verfügbare menge gesetzt, bei menge 0 wird er nicht im shop angezeigt
            "min_qty" => "0" , //mandatory 
            "use_config_min_qty" => "1" , 
            "is_qty_decimal" => "0" , //mandatory
            "backorders" => "0" , //mandatory
            "use_config_backorders" => "1" , //mandatory
            "min_sale_qty" => "10" , //mandatory  - 10 entspricht 10€ mindestbestellwert ??
            "use_config_min_sale_qty" => "1" , //mandatory 
            "max_sale_qty" => "0" , //mandatory  - 0=unendlich ??
            "use_config_max_sale_qty" => "1" , //mandatory 
            "is_in_stock" => "1" , //mandatory - wenn menge gesetzt dann auch in stock aktiv
            "notify_stock_qty" => "" , 
            "use_config_notify_stock_qty" => "1" , //mandatory
            "manage_stock" => "0" , //mandatory 
            "use_config_manage_stock" => "1" , //mandatory
            "stock_status_changed_auto" => "" , 
            "use_config_qty_increments" => "1" , //mandatory
            "qty_increments" => "0" , //mandatory 
            "use_config_enable_qty_inc" => "" , 
            "enable_qty_increments" => "0" ,  //mandatory
            "is_decimal_divided" => "0" , //mandatory 
            "_links_related_sku" => "" , 
            "_links_related_position" => "" , 
            "_links_crosssell_sku" => "" , 
            "_links_crosssell_position" => "" , 
            "_links_upsell_sku" => "" , 
            "_links_upsell_position" => "" , 
            "_associated_sku" => "" , 
            "_associated_default_qty" => "" , 
            "_associated_position" => "" , 
            "_tier_price_website" =>  isset($mengenstaffel[0]["group_id"]) ? "all" : "" , //all = gilt für alle webseiten, mengenstaffeln pro kundengruppe, all nur dann verwenden wenn tatsächlich daten vorhanden sind
            "_tier_price_customer_group" => isset($mengenstaffel[0]["group_id"]) ? $mengenstaffel[0]["group_id"] : ""  , //zB "3" - nummer der kundengruppe, alle = "all"
            "_tier_price_qty" => isset($mengenstaffel[0]["menge"]) ? $mengenstaffel[0]["menge"] : "" ,    //zB "10" - menge
            "_tier_price_price" => isset($mengenstaffel[0]["preis"]) ? $mengenstaffel[0]["preis"] : "" ,  //sonderpreis für menge
            "_group_price_website" => isset($preislisten[0]["group_id"]) ? "all" : "" ,   //all= gilt für alle webseiten, sonderpreise für gruppen, all nur dann verwenden wenn tatsächlich daten vorhanden sind
            "_group_price_customer_group" => isset($preislisten[0]["group_id"]) ? $preislisten[0]["group_id"] : ""  ,  //nummer der kundengruppe
            "_group_price_price" => isset($preislisten[0]["preis"]) ? $preislisten[0]["preis"] : "" ,    //preis für diese gruppe
            "_media_attribute_id" => "88" ,   //should be the ID value for the media attribute, in my case 88, siehe auch eav_attribute 
            "_media_image" => $picture_big , 
            "_media_lable" => "" , 
            "_media_position" => "1" , //mandatory wenn bild in _media_image übergeben wird, reihenfolge der bilddarstellung
            "_media_is_disabled" => "0" //mandatory wenn bild in _media_image übergeben wird
        );
        
        //solange wie noch zusätzliche datensätze in mehrfachelementen (zB category, mengenstaffel, preisliste etc) vorhanden sind den datensatz erweitern
        $counter=1;
        while(isset($category_names[$counter]["cat"]) || isset($mengenstaffel[$counter]["group_id"]) || isset($preislisten[$counter]["group_id"]))
        {
            $data[] = array(
                    "sku" => null, //benötigt da sonnst error
                    "_category" => isset($category_names[$counter]["cat"]) ? $category_names[$counter]["cat"] : "",
                    "_tier_price_website" =>  isset($mengenstaffel[$counter]["group_id"]) ? "all" : "" , //all = gilt für alle webseiten, mengenstaffeln pro kundengruppe, all nur dann verwenden wenn tatsächlich daten vorhanden sind
                    "_tier_price_customer_group" => isset($mengenstaffel[$counter]["group_id"]) ? $mengenstaffel[$counter]["group_id"] : ""  , //zB "3" - nummer der kundengruppe, alle = "all"
                    "_tier_price_qty" => isset($mengenstaffel[$counter]["menge"]) ? $mengenstaffel[$counter]["menge"] : "" ,    //zB "10" - menge
                    "_tier_price_price" => isset($mengenstaffel[$counter]["preis"]) ? $mengenstaffel[$counter]["preis"] : "" ,  //sonderpreis für menge
                    "_group_price_website" => isset($preislisten[$counter]["group_id"]) ? "all" : "" ,   //all= gilt für alle webseiten, sonderpreise für gruppen, all nur dann verwenden wenn tatsächlich daten vorhanden sind
                    "_group_price_customer_group" => isset($preislisten[$counter]["group_id"]) ? $preislisten[$counter]["group_id"] : ""  ,  //nummer der kundengruppe
                    "_group_price_price" => isset($preislisten[$counter]["preis"]) ? $preislisten[$counter]["preis"] : "" ,    //preis für diese gruppe
            );
            $counter++;
        }

        
        //mage::log("Start Import 1 Artikel",null,self::$logfile_name);
        $entity_id=null;
        try {
            
            /** @var $import AvS_FastSimpleImport_Model_Import */
            //$import = Mage::getModel('fastsimpleimport/import');
            $import = new AvS_FastSimpleImport_Model_Import();
            
            //setze lock bzw warte auf nächsten freien lock
            $lock = new Mage_Index_Model_Process();
            $lock->setId("artikel_import");
            $lock_wait=microtime(1);
            $lock->lockAndBlock();
            mage::log("Dauer getlock artikel_import: ".number_format(microtime(1)-$lock_wait,4),zend_log::DEBUG,self::$logfile_name); 
            
            $import_wait = microtime(true);
            
            $import
                ->setPartialIndexing(true)
                ->setBehavior(Mage_ImportExport_Model_Import::BEHAVIOR_APPEND)
                ->processProductImport($data);
                
            $import_ids=$import->getEntityAdapter()->getNewSku();
            $entity_id=$import_ids[$magento_sku]["entity_id"];
            
            //beende lock
            $lock->unlock(); 
                
            mage::log("Finisched - Dauer Product-save EntityID/HV-Id:(".$entity_id."/".$external_pid."): " . round(microtime(true) - $import_wait, 2) . "sek",zend_log::INFO,self::$logfile_name);
            $return= $entity_id;
        } catch (Exception $e) {
            //beende lock
            $lock->unlock();  
            
            mage::log("Product-save EntityID/HV-Id:(".$entity_id."/".$external_pid."), Exception:".print_r($import->getErrorMessages(),1)." - ".print_r($e->getMessage(),1)." trace:\n".$e->getTraceAsString(),zend_log::ERR,self::$logfile_name);
            $return= null;
        }
        
        //bild nach import wieder löschen
        if(isset($picture_path["path"]) && file_exists($picture_path["path"]))
            unlink($picture_path["path"]);
        
        
        return $return;
    }
    
    /**
    * Convertiert eine Category Entity ID zu dem vollen Pfad Namen zB 233 zu Drahtmodelle/Lampenschirme/Groß
    * 
    * @param mixed $magento_cid - Magento Category entoty ID
    * @param int $ignor_until_catid - optional: bis inklusive dieser category entity id wird die rückgabe im pfad ignoriert, defaultwert = root_category (Mage_Catalog_Model_Category::TREE_ROOT_ID) auch möglich default_cat (Mage::app()->getStore()->getRootCategoryId())
    * @return - Path String wenn OK, im Fehlerfall null
    * Input kam von http://www.blastar.biz/2011/07/24/how-to-get-magento-categories-with-full-paths/
    */
    public function convertCategoryIDtoCategoryPath($magento_cid,$ignor_until_catid=Mage_Catalog_Model_Category::TREE_ROOT_ID)
    {
        
        $return=null;
        $category = Mage::getModel('catalog/category');

        try
        {
            //lade pfad von category
            $category->load($magento_cid);
            $path_full = $category->getPath();
            $path_split = explode('/', $path_full);
            
            //ermittle die namen aller dazwischenliegendnen categorien
            $string_cat = '';
            foreach ($path_split as $key => $path_id)
            {
                //$key=0: magento root cat -> wird nicht ausgegeben
                //if($key>=1)
                if($path_id>$ignor_until_catid)
                {
                    $string_cat.=$category->load($path_id)->getName()."/";    
                }
            }
            
            if($string_cat!="")
                $string_cat=substr($string_cat,0,-1);
            $return = $string_cat;
        }
        catch(Exception $e)
        {
            mage::log("convertCategoryIDtoCategoryPath Exception bei CatId:".$magento_cid.", Message: ".$e->getMessage(),zend_log::ERR,self::$logfile_name);
            $return=null;
        }
        
        return $return;
    }
    
    
    /**
    * Hauptfunktion welche alle Categorien aus HV ausliest und in Magento aktualisiert
    * Zuerst via getShopGroupsFindAll die gesammte ShopgruppenID/Parent_ID Struktur auslesen
    * Danach mit getShopGroupFindById die Details zu den Shoppgruppen auslesen (u.a. Defaultartikel für Bild, Name, Beschreibung)
    * @param string $type "update" = Nur neue Daten werden aktualisiert, "full" = alle Daten werden syncronisiert
    */
    public function doCategorySync($type)
    {
        //wenn Helium nicht erreichbar abbruch
        $ping=Heliumv_Synchronization_Helper_Master::doPingHV(true);
        if($ping!=1)
            return null;
        
        //prüfe auf gültigen typ
        if($type!="update" && $type!="full")
        {
            mage::log("Caregory Sync Typ ".$type." wird nicht unterstützt, Abbruch.",zend_log::ERR,self::$category_logfile_name);
            return null;
        }
        mage::log("########## doCategorySync started #########",zend_log::INFO,self::$category_logfile_name);
        
        //Shopgruppen aus HV auslesen (je nach typ)
        $category_list=$this->getCategoryList($type);
        
        //bei vollsync deaktiviere alle aus HV kommenden kategorien welche nicht in aktuellem sync vorhanden sind 
        if($type=="full")
            $this->disableOldCategories($category_list);
            
        //wenn daten vorhanden sind
        $max_id=0;
        if($category_list!=null && isset($category_list->return->shopgroups))
        {
            //sammle alle categorien aus structur zusammen
            foreach ($category_list->return->shopgroups->shopgroup as $category)
            {
                if(!property_exists($category,"parentId"))
                    $category->parentId=0; //setze root id auf 0 (wird nicht in ss mitgeliefert)    
                
                $array_id2parent[$category->id]=$category->parentId;
                $array_id2name[$category->id]=$category->bez;
                
                //setze maximale category_id oder parent_id
                if($category->id>$max_id)
                    $max_id=$category->id;
                if($category->parentId>$max_id)
                    $max_id=$category->parentId;
            }
        
        }
        
        
        //gehe der id nach durch alle objecte
        $cat_id_counter=0;
        $dummy_and_error_parent_category_id=$this->getErrorCategoryId();
        $abbruch_counter=0;
        $abbruch_counter_max=Mage::getStoreConfig('synchronization/debug/max_sync_article'); //debugoption, bricht verarbeitung nach x kategorien ab
        while($cat_id_counter<$max_id)
        {
            //element mit dieser id ist vorhanden
            if(isset($array_id2parent[$cat_id_counter]))
            {
                //variablen initialisierung
                $external_gid=$cat_id_counter;
                $external_parent_id=$array_id2parent[$external_gid];
                if(isset($array_id2name[$external_gid]))
                    $name=$array_id2name[$external_gid];
                else
                    $name="Undefined";
                
                //ermittle magento id der parent cat
                if($external_parent_id==0)
                {
                    //root category nicht verwenden sondern alles unter der defaultkategory
                    //$magento_parent_id=Mage_Catalog_Model_Category::TREE_ROOT_ID;  //ist 1
                    $magento_parent_id=Mage::app()->getStore()->getRootCategoryId(); //ist 2
                }
                else
                {
                    //parent id bereits vorhanden
                    $magento_parent_id=$this->convertExternalGidToCategoryId($external_parent_id);
                    //gibt es eine parent id in diesem element welche nicht nicht in magento importiert wurde -> setzen
                    if($magento_parent_id==NULL)
                    {
                        $cat_name="Undefined";
                        if(isset($array_id2name[$external_parent_id]) && $array_id2name[$external_parent_id]!="")
                            $cat_name=$array_id2name[$external_parent_id];
                        
                        //erstelle dummy object (wird später automatisch aktualisiert ausser es gibt einen Fehler, dann bleibt es in der Error Kategorie stehen)
                        $magento_parent_id=$this->saveCategory($dummy_and_error_parent_category_id,$cat_name,$external_parent_id,null,0);    
                        mage::log("doCategorySync - erstelle fehlende Parent-Cat unter ErrorCategory mit ID (external/internal): ".$external_parent_id."/".$magento_parent_id." und Namen:".$cat_name." ",zend_log::WARN,self::$category_logfile_name); 
                    }   
                }
                //speichere category
                $save_start=microtime(1);
                
                //starte abholen der details und speichern syncron oder asyncron
                if(Heliumv_Synchronization_Helper_Master::getAsyncFlag())
                {
                    $scheduler_obj=new Heliumv_Synchronization_Model_Scheduler();
                    //$scheduler_obj->createSchedulerElement(get_class($this),"saveCategory",array($magento_parent_id,$name,$external_gid));
                    $scheduler_obj->createSchedulerElement(get_class($this),"processCategoryDetails",array($external_gid,$magento_parent_id),2);
                    //$magento_cid=$this->saveCategory($magento_parent_id,$name,$external_gid);
                    
                }  
                else
                {
                    //$magento_cid=$this->saveCategory($magento_parent_id,$name,$external_gid);
                    $magento_cid=$this->processCategoryDetails($external_gid,$magento_parent_id);
                }  
                
                if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
                    mage::log("Dauer saveCategory fuer external_gid:".$external_gid." in Sek: ".number_format(microtime(1)-$save_start,4),null,self::$category_logfile_name);
                
                //breche verarbeitung ab wenn debug option maximale artikel/kategorien eingestellt ist
                if($abbruch_counter_max!="" && $abbruch_counter_max!=0 && $abbruch_counter>=$abbruch_counter_max)
                {
                    mage::log("doCategorySync abgebrochen weil Maximale Debug Categorien auf ".$abbruch_counter_max." gestellt waren.",zend_log::ERR,self::$category_logfile_name); 
                    return null;
                }
                else
                {
                    $abbruch_counter++;    
                }
                
            } //if element vorhanden
            $cat_id_counter++;
            
        } //while
        
        mage::log("########## doCategorySync finished #########",zend_log::INFO,self::$category_logfile_name);
        
        return null;
    }
    
    /**
    * Speichert oder aktualisiert eine einzelne Category in Magento
    * @param mixed $magento_parent_id - die ID des übergeordneten Categoryobjectes, Root=2
    * @param mixed $cat_name - der Name der Category
    * @param mixed $external_gid - ID der Shoppgruppe aus HV
    * @param mixed $external_reference_articel_id - Übernimmt von der folgenden HV-Artikel_ID aus HV via getArticleDetails die Beschreibung (long wenn vorhanden sonnst short) und das Bild image bzw thumbnail (wenn vorhanden)
    * @param mixed $enable_category - Setzt den Status dieser Category auf Enabled, das ist das Defauiltverhalten. Für temporär anlegte Kategorien und Fehler wird dieser auf 0 gesetzt
    * @return mixed $magento_gid - Liefert die Magento Category-ID zurück
    */
    private function saveCategory($magento_parent_id,$cat_name,$external_gid,$external_reference_articel_id=null,$enable_category=1)
    {   
        $start_time=microtime(1);
        
        //lade categorie object
        $return=null;
        $category = Mage::getModel('catalog/category');
        $category->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
        //$category->setAttributeSetId($this->getDefaultAttributeSetId('catalog/category'));  
        $category->setAttributeSetId(Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/category'));  
        
        //eventuell für multishop oder cronjob aufruf ein problem 
        //VORSICHT !!! bestätigt, save categorien geht dann nichjt mehr !!!
        //Mage::app()->setCurrentStore(Mage_Core_Model_App::ADMIN_STORE_ID);
        //Mage::app()->setCurrentStore(Mage::app()->getStore()->getId());
        
        //versuche bestehende category daten zu laden wenn vorhanden
        $magento_gid=$this->convertExternalGidToCategoryId($external_gid);
        if($magento_gid!=null)
            $category->load($magento_gid);
        
        //lade parent ID, input von http://blog.storybloks.com/2011/11/09/create-category-programmatically/
        $parentCategory = Mage::getModel('catalog/category')->load($magento_parent_id);

        //werte initialisieren um exceptions wenn kein bild vorhanden ist zu unterbinden
        $data['general']['image']=array("delete"=>1); //wenn kein bild setze delete flag damit keine weitere verarbeitung für bild durchlaufen wird und damit keine exceptionbs ausgelöst werden
        $data['general']['thumbnail']=array("delete"=>1); //wenn kein bild setze delete flag damit keine weitere verarbeitung für bild durchlaufen wird und damit keine exceptionbs ausgelöst werden
        $data['general']['description']="";
        
        //Lade daten aus Referenzartikel
        if($external_reference_articel_id!=null)
        {
            //lese referenzartikeldaten aus HV
            $reference_article=$this->getArticleDetails($external_reference_articel_id);
    
            //speichere/aktualisiere kategoriebild in dateisystemwenn vorhanden
            $image_path=$this->saveCategoryPicture($reference_article);
            
            //wenn bild vorhanden speichere is in category
            if($image_path!=null)
            {
                // eventuell hier noch automatische konvertierung der bildgrößen erforderlich
                $data['general']['image']=$image_path;
                //$data['general']['image']=Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'catalog' . DIRECTORY_SEPARATOR . 'category' . DIRECTORY_SEPARATOR.$image_path;
                $data['general']['thumbnail']=$image_path;
                //$data['general']['thumbnail']=Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'catalog' . DIRECTORY_SEPARATOR . 'category' . DIRECTORY_SEPARATOR.$image_path;
                
                //selbe datenstruktur wie bei manuellem upload über backend
                /*$_FILES["thumbnail"]["name"]="2511-929500w_3.jpg";
                $_FILES["thumbnail"]["type"]="image/jpeg";
                $_FILES["thumbnail"]["tmp_name"]="C:\\xampp\\htdocs\\magento\\media\\tmp\\2511-929500w_3.jpg";
                $_FILES["thumbnail"]["error"]=0;
                $_FILES["thumbnail"]["size"]=filesize("C:\\xampp\\htdocs\\magento\\media\\tmp\\2511-929500w_3.jpg");
                $_FILES["image"]["name"]="2511-929500w_3.jpg";
                $_FILES["image"]["type"]="image/jpeg";
                $_FILES["image"]["tmp_name"]="C:\\xampp\\htdocs\\magento\\media\\tmp\\2511-929500w_3.jpg";
                $_FILES["image"]["error"]=0;
                $_FILES["image"]["size"]=filesize("C:\\xampp\\htdocs\\magento\\media\\tmp\\2511-929500w_3.jpg");*/
                
            }
            
            if(isset($reference_article->return->item->bmeCatInfo))
            {
                //setze long_description oder short_description
                $bme_cat_info = simplexml_load_string($reference_article->return->item->bmeCatInfo);
                $product = $bme_cat_info->T_NEW_CATALOG[0]->PRODUCT[0];
                if($product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG)
                    $data['general']['description'] = (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG;
                elseif($product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT)
                    $data['general']['description'] = (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT;
            }    
            
        } //if referenzartikel
        
        $data['general']['path'] = $parentCategory->getPath();
        //$data['general']['path_ids'] = $parentCategory->getPathIds();
        $data['general']['name'] = $cat_name;
        //$data['general']['meta_title'] = "";
        //$data['general']['meta_description'] = "";
        $data['general']['is_active'] = "".$enable_category."";
        //$data['general']['url_key'] = "";
        $data['general']['display_mode'] = "PRODUCTS";
        //$data['general']['is_anchor'] = 0;
        $data['general']['external_gid'] = $external_gid;
        
        //speichere pfad vorher, und pfad nachher in debug
        if(Heliumv_Synchronization_Helper_Master::getDebugFlag() && $category->getPath()!=$parentCategory->getPath())
            mage::log("Category mit Name:".$cat_name.", ändert Pfad von ".$category->getPath()."/ElementID auf ".$parentCategory->getPath()."/ElementID.",null,self::$category_logfile_name);
        
        $category->addData($data['general']);
        
        try
        {
            //bei category update muss pfad manipuliert werden
            if($magento_gid!=null)
            {
                $category->setPath($category->getPath()."/".$category->getId());    
            }
            
            //speichere category
            $category->save();
            
            //verschiebe category in richtigen pfad, benötigt zwingend elementid, desshalb erst nach save möglich
            //$category->setPath($category->getPath()."/".$category->getId());
            //$category->save();
                
            if($magento_gid==null)
                mage::log("Category mit Name:".$cat_name.", ID:".$category->getId()." und ParentID:".$magento_parent_id." und Pfad:".$category->getPath()." angelegt.",zend_log::INFO,self::$category_logfile_name);
            else
                mage::log("Category mit Name:".$cat_name.", ID:".$category->getId()." und ParentID:".$magento_parent_id." und Pfad:".$category->getPath()." aktualisiert.",zend_log::INFO,self::$category_logfile_name);

            //return category id
            $return= $category->getId();
        }
        catch (Exception $e)
        {
            Mage::log("Exception beim Speichern von Category:".$cat_name." Exception:".$e->getMessage(),zend_log::ERR,self::$category_logfile_name);
            $return=null;
        }
        
        //if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
            //mage::log("Dauer Category Save über Object für CatID:".$return." war ".number_format(microtime(1)-$start_time,4)."Sek",zend_log::DEBUG,self::$category_logfile_name);
        
        return $return;
    }
    
    /**
    * Funktion hat Probleme wenn Parent Category nicht da ist oder wenn Strting zum Schluss ein Space hat oder ähnliches, Zeitvorteil gering, Umstieg erst möglöich wenn AvS Framework mit IDs für Parent und Path funktioniert
    * 
    * Speichert oder aktualisiert eine einzelne Category in Magento - benötigt zwingend das AvS Framework
    * @param mixed $magento_parent_id - die ID des übergeordneten Categoryobjectes, default_cat = 2 = (Mage::app()->getStore()->getRootCategoryId())
    * @param mixed $cat_name - der Name der Category
    * @param mixed $external_gid - ID der Shoppgruppe aus HV
    * @param mixed $external_reference_articel_id - Übernimmt von der folgenden HV-Artikel_ID aus HV via getArticleDetails die Beschreibung (long wenn vorhanden sonnst short) und das Bild image bzw thumbnail (wenn vorhanden)
    * @param mixed $enable_category - Setzt den Status dieser Category auf Enabled, das ist das Defauiltverhalten. Für temporär anlegte Kategorien und Fehler wird dieser auf 0 gesetzt
    * @return mixed $magento_gid - Liefert die Magento Category-ID zurück
    */
    /*private function saveCategory_new($magento_parent_id,$cat_name,$external_gid,$external_reference_articel_id=null,$enable_category=1)
    {   
        $start_time=microtime(1);
        
        $return=null;

        //versuche bestehende category_id zu ermitteln wenn vorhanden
        $magento_gid=$this->convertExternalGidToCategoryId($external_gid);
        
        //lade parent ID, input von http://blog.storybloks.com/2011/11/09/create-category-programmatically/
        $parentCategory = Mage::getModel('catalog/category')->load($magento_parent_id);

        //Lade daten aus Referenzartikel
        $data_description="";
        $image="";
        if($external_reference_articel_id!=null)
        {
            //lese referenzartikeldaten aus HV
            $reference_article=$this->getArticleDetails($external_reference_articel_id);
    
            //speichere/aktualisiere kategoriebild in dateisystemwenn vorhanden
            $image_path=$this->saveArticlePicture($reference_article,1);

            //wenn bild vorhanden speichere is in category
            if(isset($image_path["name"]) && $image_path["name"]!=null && isset($image_path["path"]) && $image_path["path"]!=null)
            {
                $image=$image_path["name"];
            }
            
            //setze long_description oder short_description
            $bme_cat_info = simplexml_load_string($reference_article->return->item->bmeCatInfo);
            $product = $bme_cat_info->T_NEW_CATALOG[0]->PRODUCT[0];
            if($product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG)
                $data_description = (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG;
            elseif($product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT)
                $data_description = (string)$product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT;    
            
        } //if referenzartikel
        
        //TODO 1:prüfung ob sich name/pfad/id der kategory geändert haben
        
        
        //konvertierung binär auf yes/no
        if($enable_category==1)
            $enable_category="yes";
        else
            $enable_category="no";    
            
        //ermittle categorypfad, wenn category nicht vorhanden nimm errorcategory 
        $category_path=$this->convertCategoryIDtoCategoryPath($magento_parent_id,Mage::app()->getStore()->getRootCategoryId());
        if($category_path==null || $category_path=="")
        {
            $error_cat_id=$this->getErrorCategoryId();
            $category_path=$this->convertCategoryIDtoCategoryPath($error_cat_id,Mage::app()->getStore()->getRootCategoryId());
        }
        
        //aufbau der categorydaten
        $data[] = array(
            '_root' => $this->convertCategoryIDtoCategoryPath(Mage::app()->getStore()->getRootCategoryId()), //Default Category
            '_category' => $category_path,
            'name' => $cat_name,
            'description' => $data_description,
            'is_active' => $enable_category,
            'include_in_menu' => $enable_category, //wenn aktiv dann auch in menü anzeigen
            'meta_description' => '',
            //'available_sort_by' => 'position',
            //'default_sort_by' => 'position',
            'image' => $image,
            'thumbnail' => $image,
            'external_gid' => $external_gid,
            'url_key' => Mage::getModel('catalog/product_url')->formatUrlKey($cat_name),
        );
        
        
        
        try {
            // @var $import AvS_FastSimpleImport_Model_Import 
            $import = new AvS_FastSimpleImport_Model_Import();
            
            //setze lock bzw warte auf nächsten freien lock
            $lock = new Mage_Index_Model_Process();
            $lock->setId("category_import");
            $lock_wait=microtime(1);
            $lock->lockAndBlock();
            mage::log("Dauer getlock category_import: ".number_format(microtime(1)-$lock_wait,4),zend_log::DEBUG,self::$category_logfile_name); 
            
            $import_wait = microtime(true);
            
            // @var $import AvS_FastSimpleImport_Model_Import 
            $import = Mage::getModel('fastsimpleimport/import');
            $import
                ->setPartialIndexing(true)
                ->setBehavior(Mage_ImportExport_Model_Import::BEHAVIOR_APPEND)
                ->processCategoryImport($data);
            
            //ermittle magento_ID aufgrund helium cat_id
            if($magento_gid!=null)
                $entity_id=$magento_gid;
            else
                $entity_id=$this->convertExternalGidToCategoryId($external_gid);

            //beende lock
            $lock->unlock(); 
                
            mage::log("Finisched - Dauer Category-save EntityID(".$entity_id."), Name(".$cat_name."): " . round(microtime(true) - $import_wait, 2) . "sek",zend_log::INFO,self::$category_logfile_name);
            $return= $entity_id;
        } catch (Exception $e) {
            //beende lock
            $lock->unlock();  
            
            mage::log("Category-save EntityID(".$entity_id."), Name(".$cat_name.") Exception:".print_r($import->getErrorMessages(),1)." - ".print_r($e->getMessage(),1)." trace:\n".$e->getTraceAsString(),zend_log::ERR,self::$category_logfile_name);
            $return= null;
        }
        
        //bild nach import wieder löschen
        if(isset($image_path["path"]) && file_exists($image_path["path"]))
            unlink($image_path["path"]);
            
        if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
            mage::log("Dauer Category Save über AvS-Framework für CatID:".$return." war ".number_format(microtime(1)-$start_time,4)."Sek",zend_log::DEBUG,self::$category_logfile_name);

        return $return;
    }  */
    
    /**
    * List eine Liste aller Categorien inklusive deren Struktur aus HV aus
    * @param mixed $type = full, dann werden alle vorhandenen categorien aktualisiert, update, dann werden nur die seit dem letzten artikelsync geholt
    * @return liefert soap-result oder im fehlerfall null zurück
    */
    private function getCategoryList($type)
    {
        
        //ermittle letztgültigen sync zeitstempel
        if($type=="update")
        {
            $ts_sync=gmdate("Y-m-d H:i:s"); //initialwert mit utc time setzen
            $ts_last_sync=Mage::getStoreConfig('synchronization/synctools/last_sync_ts');
            if(isset($ts_last_sync) and $ts_last_sync!="" and strtotime($ts_last_sync)>0)
            {
                $ts_sync=$ts_last_sync;  
            }
            mage::log("Verwende Zeitstempel letzter Artikelsync ".$ts_sync,null,self::$category_logfile_name);
        }
        
        $options = array('trace' => 1);
        $login = Heliumv_Synchronization_Helper_Master::getWebserviceHeaderData();
        $server_url=Heliumv_Synchronization_Helper_Master::getWebserviceUrlArticle();
        $return=null;
        
        try
        {
            //prevent running into a timeout
            set_time_limit(Mage::getStoreConfig('synchronization/heliumvconnect/soap_timeout'));
            //neuen soapclient aufmachen
            $client = new SoapClient($server_url,$options);
            
            //get item from the heliumv instance
            if($type=="update")
                $result = $client->getShopGroupsFlatFindAllChanged(array('arg0' => $login, 'changedDateTime' => $ts_sync));  
            if($type=="full")
                $result = $client->getShopGroupsFlatFindAll(array('arg0' => $login)); 

                
            //bei positiver rückmeldung
            if ($result->return->rc == 0 && isset($result->return->shopgroups))
            {                
                $return=$result;
            }
            else
            {
                if(isset($result->return->shopgroups))
                    $count=count($result->return->shopgroups);
                else
                    $count=0;
                
                mage::log("getCategoryList - Keine Daten zu Shoppgruppen (AnzahlHauptelemente=".$count.") gefunden oder RC<>0 bei Rückgabe. (RC=".$result->return->rc.")",zend_log::INFO,self::$category_logfile_name);
                $return=null;
            }
        }
        catch(SoapFault $exc)
        {
            mage::log("getCategoryList Fehler bei Shopgruppen Call getShopGroupsFindAll - Exeption:".$exc->getMessage(),zend_log::ERR,self::$category_logfile_name);       
            $return=null;  
        }      
        
        //wenn debug aktiv schreibe request und response in debug
        if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
        {
            Heliumv_Synchronization_Helper_Master::debugLog("getCategoryList_request.xml",$client->__getLastRequest() ,"no",gmdate("Ymd"));
            Heliumv_Synchronization_Helper_Master::debugLog("getCategoryList__response.xml",$client->__getLastResponse() ,"no",gmdate("Ymd"));
        }
        
        $client=null;
        return $return;
    }
    
    /**
    * Liest Details zu eine Category aus HV
    * @param mixed $external_gid HV Shopgruppen ID
    * @return liefert soap-result oder im fehlerfall null zurück
    */
    private function getCategoryDetails($external_gid)
    {
        $options = array('trace' => 1);
        $login = Heliumv_Synchronization_Helper_Master::getWebserviceHeaderData();
        $server_url=Heliumv_Synchronization_Helper_Master::getWebserviceUrlArticle();
        $return=null;
        
        try
        {
            //prevent running into a timeout
            set_time_limit(Mage::getStoreConfig('synchronization/heliumvconnect/soap_timeout'));
            //neuen soapclient aufmachen
            $client = new SoapClient($server_url,$options);
            //get item from the heliumv instance
            $result = $client->getShopGroupFindById(array('arg0' => $login,'id' => $external_gid)); 

            //bei positiver rückmeldung
            if ($result->return->rc == 0 && isset($result->return->webshopGroup->id))
            {                
                $return=$result;
            }
            else
            {
                mage::log("getCategoryDetails - Keine Daten zu Shoppgruppe:".$external_gid." gefunden oder RC<>0 bei Rückgabe. (RC=".$result->return->rc.")",zend_log::INFO,self::$category_logfile_name);
                $return=null;
            }
        }
        catch(SoapFault $exc)
        {
            mage::log("getCategoryDetails Shoppgruppe:".$external_gid." - Exeption:".$exc->getMessage(),zend_log::ERR,self::$category_logfile_name);       
            $return=null;  
        }      
        
        //wenn debug aktiv schreibe request und response in debug
        if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
        {
            Heliumv_Synchronization_Helper_Master::debugLog("getCategoryDetails_".$external_gid."_request.xml",$client->__getLastRequest() ,"no",gmdate("Ymd"));
            Heliumv_Synchronization_Helper_Master::debugLog("getCategoryDetails_".$external_gid."_response.xml",$client->__getLastResponse() ,"no",gmdate("Ymd"));
        }
        
        $client=null;
        return $return;
    }
    
    
    /**
    * Aktualisiert/Erstellt die Produkt-Bilder auf Basis der Daten aus SoapCall getItemFindById 
    * @param mixed $magento_pid - Magento Produkt ID
    * @param mixed $articel_detail - Response aus SoapCall getItemFindById
    */
    /*private function saveArticlePicture_old($magento_pid,$articel_detail)
    {
        
        $return = null;
        $bme_cat_info = simplexml_load_string($articel_detail->return->item->bmeCatInfo);
        $product = $bme_cat_info->T_NEW_CATALOG[0]->PRODUCT[0];
        if(isset($articel_detail->return->item->image))
            $image = $articel_detail->return->item->image;
        else
            $image=null;
        
        if ($image!=null) 
        {
            $source = $product->MIME_INFO->MIME->MIME_SOURCE;
            $img = imagecreatefromstring($image);
            if ($img !== false)
            {
                $path = Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'tmp' . DIRECTORY_SEPARATOR;
                if(!file_exists($path))
                    mkdir($path);
                //header('Content-Type: ' . $product->MIME_INFO->MIME->MIME_TYPE);
                imagejpeg($img, $path . $source);
                imagedestroy($img);
                // try to save the image information
                try
                {
                    //variablen setzen
                    $filename_new=current($source);
                    $final_path= Mage::getBaseDir('media') . DIRECTORY_SEPARATOR .'catalog'. DIRECTORY_SEPARATOR . 'product' . DIRECTORY_SEPARATOR . substr($filename_new,0,1) .DIRECTORY_SEPARATOR . substr($filename_new,1,1) .DIRECTORY_SEPARATOR;
                    $item = Mage::getModel('catalog/product');
                    $item->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
                    //Mage::app()->setCurrentStore(Mage::app()->getStore()->getId());
                    $item->setAttributeSetId(Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/product'));    
                    $item->load($magento_pid);
                    
                    //wenn bild mit selbem namen vorhanden dieses löschen (verhindert dass bild mehrfach mit bild_1, _2 .. an produkt angehängt wird)
                    if(file_exists($final_path.$filename_new))
                        unlink($final_path.$filename_new);
                    
                    //bild an product anfügen und von temp nehmen
                    $item->addImageToMediaGallery($path . $source, array("thumbnail", "small_image", "image"));
                        
                    //produkt speichern
                    $item->save();
                    
                    //file von temp löschen
                    if(file_exists($path . $source))
                        unlink($path . $source);
                    
                    //schreibe logeintrag über erstellung
                    Mage::log("Bild:".$filename_new." zu Magento_PID:".$magento_pid." hinzugefuegt.",zend_log::INFO,self::$logfile_name);
                    
                    $return= $magento_pid;
                }
                catch (Exception $ex)
                {
                    Mage::log("Exception beim Speichern des Bildes von PID:".$magento_pid.", Exception:".$ex->getMessage(),zend_log::ERR,self::$logfile_name);
                    $return = null;
                    if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
                    {
                        Heliumv_Synchronization_Helper_Master::debugLog("ExeptionTrace_ArticlePictureID_".$external_pid.".log",$ex->getTraceAsString(),"no",gmdate("Ymd"));
                    }
                }
            }
            else
            {
                Mage::log("Bilderstellung bei PID:".$magento_pid." fehlgeschlagen",zend_log::ERR,self::$logfile_name); 
                $return = null; 
            }
        }  
        return $return;
    }  */
    
    /**
    * Aktualisiert/Erstellt ein Produkt Bild mit eindeutigem Namen auf Basis der Daten aus SoapCall getItemFindById 
    * @param mixed $articel_detail - Response aus SoapCall getItemFindById
    * @param mixed $use_avs_import - optional, wenn auf 1 gesetzt werden bilder in /media/import/bild.jpg abgelegt und nicht automatisch gelöscht, wird für avs import benötigt
    * @return - pfad zu Bild für verwendung in addImageToMediaGallery, im fehlerfall null
    */
    private function saveArticlePicture($articel_detail,$use_avs_import=0)
    {
        
        $return = null;
        $bme_cat_info = simplexml_load_string($articel_detail->return->item->bmeCatInfo);
        $product = $bme_cat_info->T_NEW_CATALOG[0]->PRODUCT[0];
        if(isset($articel_detail->return->item->image))
            $image = $articel_detail->return->item->image;
        else
            $image=null;
        
        if ($image!=null) 
        {
            $source = $product->MIME_INFO->MIME->MIME_SOURCE;
            $img = imagecreatefromstring($image);
            if ($img !== false)
            {
                $path = Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'tmp' . DIRECTORY_SEPARATOR;
                if(!file_exists($path))
                    mkdir($path);
                //header('Content-Type: ' . $product->MIME_INFO->MIME->MIME_TYPE);
                
                //pro mime_type eine andere routine aufrufen
                $mime_typ="not set";
                if(isset($product->MIME_INFO->MIME->MIME_TYPE) && $product->MIME_INFO->MIME->MIME_TYPE!="")
                    $mime_typ=strtolower($product->MIME_INFO->MIME->MIME_TYPE);
                if($mime_typ=="image/jpeg")
                {
                    imagejpeg($img, $path . $source);    
                }
                elseif($mime_typ=="image/png")
                {
                    //imagepng($img, $path . $source);
                    $fp = fopen($path . $source, 'w');
                    fwrite($fp, $image);
                    fclose($fp);       
                }
                elseif($mime_typ=="image/gif")
                {
                    //imagegif($img, $path . $source);
                    $fp = fopen($path . $source, 'w');
                    fwrite($fp, $image);
                    fclose($fp);     
                }
                else
                {
                    mage::log("saveArticlePicture - ".$source." abgebruchen da MimeType:".$mime_typ." nicht unterstuetzt wird.",zend_log::ERR,self::$logfile_name);
                }
                imagedestroy($img);
                
                // try to save the image information
                try
                {
                    //erzeuge image datei
                    $fp = fopen($path . $source, 'w');
                    fwrite($fp, $image);
                    fclose($fp);  
                    
                    //variablen setzen
                    $filename_new=(string)$source;
                    if($use_avs_import==1)
                        $final_path= Mage::getBaseDir('media') . DIRECTORY_SEPARATOR .'import'. DIRECTORY_SEPARATOR;
                    else
                        $final_path= Mage::getBaseDir('media') . DIRECTORY_SEPARATOR .'catalog'. DIRECTORY_SEPARATOR . 'product' . DIRECTORY_SEPARATOR . substr($filename_new,0,1) .DIRECTORY_SEPARATOR . substr($filename_new,1,1) .DIRECTORY_SEPARATOR;

                    if($use_avs_import==1)
                    {
                        if(!file_exists(mage::getBaseDir("media").DIRECTORY_SEPARATOR."import"))
                            mkdir(mage::getBaseDir("media").DIRECTORY_SEPARATOR."import");
                        
                        rename($path . $source,$final_path.$filename_new);    
                    }   
                    else
                    { 
                        //wenn bild mit selbem namen vorhanden dieses löschen (verhindert dass bild mehrfach mit bild_1, _2 .. an produkt angehängt wird)
                        if(file_exists($final_path.$filename_new))
                            unlink($final_path.$filename_new);
                    }
                    
                    $return= array("path"=>$final_path . $filename_new,"name"=>$filename_new);
                }
                catch (Exception $ex)
                {
                    Mage::log("Exception beim Speichern des Bildes ".current($source).", Exception:".$ex->getMessage(),zend_log::ERR,self::$logfile_name);
                    $return = null;
                    if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
                    {
                        if(!isset($external_pid))
                            $external_pid="undef";
                        Heliumv_Synchronization_Helper_Master::debugLog("ExeptionTrace_ArticlePictureID_".$external_pid.".log",$ex->getTraceAsString(),"no",gmdate("Ymd"));
                    }
                }
            }
            else
            {
                Mage::log("Bilderstellung von Bild ".current($source)." fehlgeschlagen",zend_log::ERR,self::$logfile_name); 
                $return = null; 
            }
        }  
        return $return;
    }
    
    /**
    * Erstellt/Aktualisiert ein Categorie Bild auf Basis der Artikeldaten aus SoapCall getItemFindById 
    * @param mixed $articel_detail - Response aus SoapCall getItemFindById
    * @return mixed - liefert null im fehler oder pfad zum image file nach /media/catalog/category
    */
    private function saveCategoryPicture($articel_detail)
    {
        //wenn keine bme_cat_info gefunden -> abbruch
        if(!isset($articel_detail->return->item->bmeCatInfo))
            return null;
        
        $source="";
        $bme_cat_info = simplexml_load_string($articel_detail->return->item->bmeCatInfo);
        $product = $bme_cat_info->T_NEW_CATALOG[0]->PRODUCT[0];
        if(isset($articel_detail->return->item->image))
            $image = $articel_detail->return->item->image;
        else
            $image=null;
        
        if ($image!=null) 
        {
            $source = $product->MIME_INFO->MIME->MIME_SOURCE;
            $img = imagecreatefromstring($image);
            if ($img !== false)
            {
                $path = Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'tmp' . DIRECTORY_SEPARATOR;
                if(!file_exists($path))
                    mkdir($path);
                //header('Content-Type: ' . $product->MIME_INFO->MIME->MIME_TYPE);
                
                //pro mime_type eine andere routine aufrufen
                $mime_typ="not set";
                if(isset($product->MIME_INFO->MIME->MIME_TYPE) && $product->MIME_INFO->MIME->MIME_TYPE!="")
                    $mime_typ=strtolower($product->MIME_INFO->MIME->MIME_TYPE);
                if($mime_typ=="image/jpeg")
                {
                    imagejpeg($img, $path . $source);    
                }
                elseif($mime_typ=="image/png")
                {
                    //imagepng($img, $path . $source); 
                    $fp = fopen($path . $source, 'w');
                    fwrite($fp, $image);
                    fclose($fp);   
                }
                elseif($mime_typ=="image/gif")
                {
                    //imagegif($img, $path . $source);
                    $fp = fopen($path . $source, 'w');
                    fwrite($fp, $image);
                    fclose($fp);        
                }
                else
                {
                    mage::log("saveCategoryPicture - ".$source." abgebrochen da MimeType:".$mime_typ." nicht unterstuetzt wird.",zend_log::ERR,self::$category_logfile_name);
                }
                imagedestroy($img);
                
                $path_cat_short="heliumv_syncronisation/";
                $path_cat = Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'catalog' . DIRECTORY_SEPARATOR . 'category' . DIRECTORY_SEPARATOR . 'heliumv_syncronisation' . DIRECTORY_SEPARATOR  ;
                
                if(!file_exists(Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'catalog'))
                    mkdir(Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'catalog');
                if(!file_exists(Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'catalog' . DIRECTORY_SEPARATOR . 'category'))
                    mkdir(Mage::getBaseDir('media') . DIRECTORY_SEPARATOR . 'catalog' . DIRECTORY_SEPARATOR . 'category');
                if(!file_exists($path_cat))
                    mkdir($path_cat);
                    
                $path_cat_short="heliumv_syncronisation/";
                
                //wenn datei tatsächlich vorhanden -> daten setzen und datei copieren
                if(file_exists($path . $source))
                {
                    copy($path . $source,$path_cat.$source); //überschreibt file wenn vorhanden
                    //lösche temporär erstelltes bild
                    unlink($path . $source);
                    //liefere image pfad wie zum speichern für cat benötigt zurück
                    return $path_cat_short.$source;
                    
                } //if file exists

            } //if image created in filesystem
        } //if image in xml  
        if(Heliumv_Synchronization_Helper_Master::getDebugFlag())
            Mage::log("Bilderstellung von Bild:".$source." aus Artikel ".$articel_detail->return->item->id." nicht möglich da Bild in XML nicht vorhanden",zend_log::DEBUG,self::$category_logfile_name);
        return null;
    }
    
    
    
    
    
    /**
    * Ermittelt ProductTaxClass oder erstellt Sie wenn nicht gefunden fix mit dem Namen "<Nummer>+% MWST"
    * @param number $taxProcent entsprocht dem mehrwertsteuersatz aus bmecat, also 10% ist 0.1, 20% ist 0.2 und so weiter
    * @return liefert ID der ProductTaxClasse zurück um sie zB beim Product mit tax_class_id zu setzen
    */
    private function checkTaxClass($taxProcent)
    {
        
        $taxProcent=number_format(floatval($taxProcent)*100,0);
        
        $fix_name=$taxProcent."% MWST";
        
        $resource = Mage::getSingleton('core/resource');
        $sql="SELECT class_id FROM ".$resource->getTableName("tax_class")." where class_name='".$fix_name."' and class_type='".Mage_Tax_Model_Class::TAX_CLASS_TYPE_PRODUCT."'";
        $db_read = $resource->getConnection('core_read');
        $sqlresult = $db_read->fetchRow($sql);
        if(isset($sqlresult["class_id"]) && $sqlresult["class_id"]!="")
        {
            $tax_class_id=$sqlresult["class_id"];
        }
        else 
        {
            $model_new  = Mage::getModel('tax/class');    
            $model_new->setData("class_name",$fix_name);
            $model_new->setData("class_type",Mage_Tax_Model_Class::TAX_CLASS_TYPE_PRODUCT);
            $model_new=$model_new->save();
            $tax_class_id=$model_new->getId();
            mage::log("Neue Product TaxClasse mit Namen:".$fix_name." und ID:".$tax_class_id."angelegt.",zend_log::INFO,self::$logfile_name);
        }
        return $tax_class_id;
    }
    
    /**
    * Konvertiert eine externe HV Produkt_id in eine Magento Product ID, versuche zugriff zuerst via object, dann via sql
    * @param mixed $external_pid
    * @return wird keine gefunden kommt null zurück
    */
    public function convertExternalPidToPid($external_pid)
    {
        //$store_id=Mage::app()->getStore()->getId();
    
        //beispiel um product_id by attribut zu finden von http://fishpig.co.uk/blog/load-a-category-or-product-by-an-attribute.html  
        // Instantiate a product collection object
        $products = Mage::getResourceModel('catalog/product_collection');
        //setze den jeweiligen shop
        $products->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
        // Select which fields to load into the product, * will load all fields but it is possible to pass an array of
        $products->addAttributeToSelect('external_pid');
        // Add Name filter
        $products->addAttributeToFilter('external_pid', $external_pid);
        // Limit the collection to 1 result
        $products->setCurPage(1)->setPageSize(1);
        // Load the collection
        $products->load();
        
        if ($products->getFirstItem()->getEntityId())
        {
            //sollte es die daten mehrfach geben wird immer der erste artikel zurückgegeben
            $product_id=$products->getFirstItem()->getEntityId();
        }
        else 
        {
            //prüfe zusätzlich ob auch direkt via sql nichts gefunden werden kann
            $resource = Mage::getSingleton('core/resource');
            $sql="SELECT a.entity_id FROM ".$resource->getTableName("catalog_product_entity_varchar")." a, ".$resource->getTableName("eav_attribute")." b where b.attribute_code='external_pid' and a.entity_type_id=b.entity_type_id and a.attribute_id=b.attribute_id and a.value='".$external_pid."'";
            $db_read = $resource->getConnection('core_read');
            $sqlresult = $db_read->fetchRow($sql);
            if(isset($sqlresult["entity_id"]) && $sqlresult["entity_id"]!="")
                $product_id=$sqlresult["entity_id"];
            else
                $product_id=null;
        }
        return $product_id;
    }
    
    /**
    * Konvertiert eine externe HV Produkt_id in eine Magento Product Sku, versuche zugriff zuerst via object, dann via sql
    * @param mixed $external_pid
    * @return wird keine gefunden kommt null zurück
    */
    public function convertExternalPidToSku($external_pid)
    {
        //$store_id=Mage::app()->getStore()->getId();
    
        //beispiel um product_id by attribut zu finden von http://fishpig.co.uk/blog/load-a-category-or-product-by-an-attribute.html  
        // Instantiate a product collection object
        $products = Mage::getResourceModel('catalog/product_collection');
        //setze den jeweiligen shop
        $products->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
        // Select which fields to load into the product, * will load all fields but it is possible to pass an array of
        $products->addAttributeToSelect('external_pid');
        // Add Name filter
        $products->addAttributeToFilter('external_pid', $external_pid);
        // Limit the collection to 1 result
        $products->setCurPage(1)->setPageSize(1);
        // Load the collection
        $products->load();
        
        if ($products->getFirstItem()->getEntityId())
        {
            //sollte es die daten mehrfach geben wird immer der erste artikel zurückgegeben
            $product_id=$products->getFirstItem()->getSku();
        }
        else 
        {
            //prüfe zusätzlich ob auch direkt via sql nichts gefunden werden kann
            $resource = Mage::getSingleton('core/resource');
            $sql="SELECT a.entity_id,c.sku FROM ".$resource->getTableName("catalog_product_entity_varchar")." a, ".$resource->getTableName("eav_attribute")." b, ".$resource->getTableName("catalog_product_entity")." c where a.entity_id=c.entity_id and b.attribute_code='external_pid' and a.entity_type_id=b.entity_type_id and a.attribute_id=b.attribute_id and a.value='".$external_pid."'";
            $db_read = $resource->getConnection('core_read');
            $sqlresult = $db_read->fetchRow($sql);
            if(isset($sqlresult["sku"]) && $sqlresult["sku"]!="")
                $product_id=$sqlresult["sku"];
            else
                $product_id=null;
        }
        return $product_id;
    }
    
    /**
    * Konvertiert eine externe HV Shoppgruppen_id (external_gid) in eine Magento Category ID, versuche zugriff zuerst via object, dann via sql
    * @param mixed $external_gid
    * @return wird keine gefunden kommt null zurück
    */
    public function convertExternalGidToCategoryId($external_gid)
    {
        //$store_id=Mage::app()->getStore()->getId();
    
        //beispiel um object_id by attribut zu finden von http://fishpig.co.uk/blog/load-a-category-or-product-by-an-attribute.html  
        // Instantiate a category collection object
        $cat = Mage::getResourceModel('catalog/category_collection');
        //setze den jeweiligen shop
        $cat->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
        // Select which fields to load into the category, * will load all fields but it is possible to pass an array of
        $cat->addAttributeToSelect('external_gid');
        // Add Name filter
        $cat->addAttributeToFilter('external_gid', $external_gid);
        // Limit the collection to 1 result
        $cat->setCurPage(1)->setPageSize(1);
        // Load the collection
        $cat->load();
        
        if ($cat->getFirstItem()->getEntityId())
        {
            //sollte es die daten mehrfach geben wird immer das erste object zurückgegeben
            $cat_id=$cat->getFirstItem()->getEntityId();
        }
        else 
        {
            //prüfe zusätzlich ob auch direkt via sql nichts gefunden werden kann
            $resource = Mage::getSingleton('core/resource');
            $sql="SELECT a.entity_id FROM ".$resource->getTableName("catalog_category_entity_varchar")." a, ".$resource->getTableName("eav_attribute")." b where b.attribute_code='external_gid' and a.entity_type_id=b.entity_type_id and a.attribute_id=b.attribute_id and a.value='".$external_gid."'";
            $db_read = $resource->getConnection('core_read');
            $sqlresult = $db_read->fetchRow($sql);
            if(isset($sqlresult["entity_id"]) && $sqlresult["entity_id"]!="")
                $cat_id=$sqlresult["entity_id"];
            else
                $cat_id=null;
        }
        return $cat_id;
    }
    
    /**
    * Löscht alle Article und Categories in dem aktuellen magento shop
    */
    public function deleteAllArticlesAndCategories()
    {
        //initialisierung
        Mage::app()->setCurrentStore(Mage::getModel('core/store')->load(Mage_Core_Model_App::ADMIN_STORE_ID));
        $resource = Mage::getSingleton('core/resource');
        $db_read = $resource->getConnection('core_read');
        $count_prod=0;
        $count_cat=0;

        //lösche alle kategorien
        //$sql="SELECT a.entity_id FROM ".$resource->getTableName("customer_entity_varchar")." a, ".$resource->getTableName("eav_attribute")." b where b.attribute_code='external_cid' and a.entity_type_id=b.entity_type_id and a.attribute_id=b.attribute_id and a.value is not null and a.value<>''";
        $sql="SELECT a.entity_id FROM ".$resource->getTableName("catalog_category_entity_varchar")." a, ".$resource->getTableName("eav_attribute")." b where b.attribute_code='external_gid' and a.entity_type_id=b.entity_type_id and a.attribute_id=b.attribute_id and a.value is not null and a.value<>'' ORDER BY a.entity_id DESC";
        //$categories = $db_read->fetchCol("SELECT entity_id FROM " . $resource->getTableName("catalog_category_entity") . " WHERE parent_id<>0 ORDER BY entity_id DESC");
        $categories = $db_read->fetchCol($sql);
        foreach ($categories as $category_id) {
            try {
                Mage::getModel("catalog/category")->load($category_id)->delete();
                $count_cat++;
            } catch (Exception $ex) {
                Mage::log("Fehler beim Löschen der Category:".$category_id.", Exception:".$ex->getMessage());
            }
        }
        //delete all products
        //$products = $db_read->fetchCol("SELECT entity_id FROM " . $resource->getTableName("catalog_product_entity") . "  ORDER BY entity_id DESC");
        $sql="SELECT a.entity_id FROM ".$resource->getTableName("catalog_product_entity_varchar")." a, ".$resource->getTableName("eav_attribute")." b where b.attribute_code='external_pid' and a.entity_type_id=b.entity_type_id and a.attribute_id=b.attribute_id and a.value is not null and a.value<>'' ORDER BY a.entity_id DESC";
        $products = $db_read->fetchCol($sql);
        foreach ($products as $product_id) {
            try {
                Mage::getModel("catalog/product")->load($product_id)->delete();
                $count_prod++;
            } catch (Exception $ex) {
                Mage::log("Fehler beim Löschen des Products:".$category_id.", Exception:".$ex->getMessage());
            }
        }
        mage::log("deleteAllArticlesAndCategories - Es wurden manuell ".$count_prod." Producte und ".$count_cat." Categories gelöscht.",zend_log::INFO,self::$logfile_name);
    }
    
    /**
    * Gibt die Error-Category ID aus Konfig zurück, ist noch keine Kategory angelegt wird sie unter der Default-Category erstellt und in Konfig gespeichert
    */
    public function getErrorCategoryId()
    {
        $category_id="";
        
        //lies daten aus konfig
        $error_cat_id=Mage::getStoreConfig('synchronization/synctools/error_category');
        
        //lies daten aus object
        if($error_cat_id!="")
        {
            $category_id = Mage::getModel('catalog/category')->load($error_cat_id)->getId();
        }
        
        //wenn object vorhanden -> return
        if($category_id!="")
        {
            return $category_id;
        }
        else
        {
            //object anlegen -> return    
            $return=null;
            $category = Mage::getModel('catalog/category');
            $category->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
            $category->setAttributeSetId(Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/category'));  
            //$data['general']['path'] = Mage_Catalog_Model_Category::TREE_ROOT_ID; //errorcategory direkt unter root category anlegen
            $data['general']['path'] = Mage_Catalog_Model_Category::TREE_ROOT_ID."/".Mage::app()->getStore()->getRootCategoryId(); //errorcategory wird unter der defaultkategory angelkegt das es sonnst probleme beim avs artikelimport gibt
            $data['general']['name'] = "Error Category";
            $data['general']['description'] = "This disabled Category is used within the HeliumV Syncronisation and will be used as Category/Category-Parent/Artikle-Category if the Category the Script is trying to access does not exist or for moving the Elements to if a Category gets deleted in HeliumV.";
            $data['general']['is_active'] = "0";
            $data['general']['display_mode'] = "PRODUCTS";
            $data['general']['is_anchor'] = 0;
            $category->addData($data['general']);
        
            try
            {
                $category->save();
                $return= $category->getId();
                
                //error Category in Konfig speichern
                Mage::getConfig()->saveConfig('synchronization/synctools/error_category', $return );
                Mage::getConfig()->reinit();
                Mage::app()->reinitStores();
                mage::log("Error Category mit ID:".$category->getId()." angelegt und Konfig aktualisiert.",zend_log::INFO,self::$category_logfile_name);
                
            }
            catch (Exception $e)
            {
                Mage::log("Exception beim Speichern von Error Category Exception:".$e->getMessage(),zend_log::ERR,self::$category_logfile_name);
                $return=null;
            }
            return $return;      
        } //else
    }
    
    /**
    * Deaktiviert alle Artikel welche aus HV importiert wurden (external_pid) und nicht in aktuellen Daten in $article_list vorhanden sind
    * @param mixed $article_list - soap call return aus getItems
    */
    private function disableOldArticles($article_list)
    {   
        try
        {
            //sammle alle category IDs aus call zusammen
            if($article_list!=null && isset($article_list->return->items->item))
            {
                foreach ($article_list->return->items->item as $product)
                {
                    $id_list[$product->id]=1;    
                }
            }
            
            //sammle alle categorien aus magento welche eine externe ID haben und aktiv sind
            $collection = Mage::getResourceModel('catalog/product_collection');
            //setze den jeweiligen shop
            $collection->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
            // Select which fields to load into the product, * will load all fields but it is possible to pass an array of
            $collection->addAttributeToSelect('status');
            $collection->addAttributeToSelect('external_pid');
            // Add Name filter
            $collection->addAttributeToFilter('status', Mage_Catalog_Model_Product_Status::STATUS_ENABLED);
            //input von http://www.magentocommerce.com/wiki/1_-_installation_and_configuration/using_collections_in_magento        
            $collection->addAttributeToFilter('external_pid', array( 'notnull' => true,));
            // Load the collection
            $collection->load();
            
            foreach($collection as $product)
            {
                
                $prod_id=$product->getEntityId();
                $ext_id=$product->getData("external_pid");
                
                //wenn nicht in daten vorhanden -> deaktivieren und name ändern
                if(!isset($id_list[$ext_id]))
                {
                    //fast version of product save for single attributes, input von hier: http://stackoverflow.com/questions/10044506/disabling-a-magento-product-via-code
                    $storeId=Heliumv_Synchronization_Helper_Master::getStoreId();
                    Mage::getSingleton('catalog/product_action')->updateAttributes(array($prod_id), array('status' => Mage_Catalog_Model_Product_Status::STATUS_DISABLED), $storeId);
                    $prod_name = Mage::getModel('catalog/product')->load($prod_id)->getName();
                    Mage::getSingleton('catalog/product_action')->updateAttributes(array($prod_id), array('name' => $prod_name." (in HV disabled)"), $storeId);
                    
                    mage::log("disableOldArticles - Product mit ID:".$prod_id.", ExtID:".$ext_id." deaktiviert da nicht mehr von HV uebertragen.",zend_log::WARN,self::$logfile_name);    
                }   
            }
            return true;
        }
        catch(Exception $e)
        {
            mage::log("disableOldArticles - Exception:".$e->getMessage(),zend_log::ERR,self::$category_logfile_name);
            return null;        
        } 
    }
    
    /**
    * Deaktiviert alle Kategorien welche aus HV importiert wurden (external_gid) und nicht in aktuellen Daten in $category_list vorhanden sind
    * @param mixed $category_list - soap call return aus getShopGroupsFlatFindAll
    */
    private function disableOldCategories($category_list)
    {
        try
        {
            //sammle alle category IDs aus call zusammen
            if($category_list!=null && isset($category_list->return->shopgroups))
            {
                foreach ($category_list->return->shopgroups->shopgroup as $category)
                {
                    $id_list[$category->id]=1;    
                }
            }
            
            //sammle alle categorien aus magento welche eine externe ID haben und aktiv sind
            $collection = Mage::getResourceModel('catalog/category_collection');
            //setze den jeweiligen shop
            $collection->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
            // Select which fields to load into the product, * will load all fields but it is possible to pass an array of
            $collection->addAttributeToSelect('is_active');
            $collection->addAttributeToSelect('external_gid');
            // Add Name filter
            $collection->addAttributeToFilter('is_active', 1);
            //input von http://www.magentocommerce.com/wiki/1_-_installation_and_configuration/using_collections_in_magento        
            $collection->addAttributeToFilter('external_gid', array( 'notnull' => true,));
            // Load the collection
            $collection->load();
            
            foreach($collection as $category)
            {
                
                $cat_id=$category->getEntityId();
                $ext_id=$category->getData("external_gid");
                
                //wenn nicht in daten vorhanden -> deaktivieren und name ändern
                if(!isset($id_list[$ext_id]))
                {
                    $cat_obj = Mage::getModel('catalog/category')->load($cat_id);
                    $cat_name=$cat_obj->getName();
                    $cat_obj->setData('is_active', 0);
                    $cat_obj->setData('name', $cat_name." (in HV disabled)");
                    $cat_obj->save();
                    mage::log("disableOldCategories - Cateory mit ID:".$cat_id.", ExtID:".$ext_id." deaktiviert da nicht mehr von HV uebertragen.",zend_log::WARN,self::$category_logfile_name);    
                }   
            }
            return true;
        }
        catch(Exception $e)
        {
            mage::log("disableOldCategories - Exception:".$e->getMessage(),zend_log::ERR,self::$category_logfile_name);
            return null;        
        }

    }
    
    
}

?>